'********************************************
'  HPCI-CTR520 series
'  Sample Program for VB.NET2003
'      file name:spct5203.vb
'      date     :2010/06/11
'      version  :1.0.0
'********************************************

Option Strict Off
Option Explicit On
Module Module1

	Public Const ZTM_PORT As Byte = &H20	' yACxg^C}j^|[g
	Public Const INP_PORT As Byte = &H28	' ėp̓|[g
	Public Const OUT_PORT As Byte = &H2C	' ėpo̓|[g
	Public Const CMP_PORT As Byte = &H30	' Rp[^o͐ݒ|[g
	Public Const TMR_PORT As Byte = &H32	' Cxg^C}o͐ݒ|[g

	' vo͐ݒ|[g
	' XY/ZUOUT1`4ٽ104msec
	' XY/ZUOUT1,2o͑I
	Public Const CIN_PORT As Byte = &H34

	Public Const CLR_PORT As Byte = &H36	' JE^NAݒ|[g
	Public Const LTC_PORT As Byte = &H38	' b`ݒ|[g
	Public Const INT_PORT As Byte = &H50	' }XNݒ|[g
	Public Const PCI_PORT As Byte = &H52	' PCIoXւ̊}XNݒ|[g

	Public Const M_CH As Short = 4 ' ch ő吔(ftHg4)
	Public Const X_CH As Short = 0 ' Xch
	Public Const Y_CH As Short = 1 ' Ych
	Public Const Z_CH As Short = 2 ' Zch
	Public Const U_CH As Short = 3 ' Uch

	Public Const MLT1_NO As Short = 0 ' JEg͌`(ʑ {w1)
	Public Const MLT2_NO As Short = 1 ' JEg͌`(ʑ {w2)
	Public Const MLT4_NO As Short = 2 ' JEg͌`(ʑ {w4)
	Public Const UPDN_NO As Short = 3 ' JEg͌`(UP/DOWNpX)
	Public Const DIRC_NO As Short = 5 ' JEg͌`(ƃpX)

	Public Const CNTMAX As Integer = 16 ' {[hő喇 16
	Public Const ILL_PARAM As Integer = &H100	' ֐N̈G[

	Public Const BRD_ID As Integer = 0 ' {[hhc

	Public hDev As Integer ' foCXnh
	Public gBrdID As Integer ' {[hhc

	Public Function sct520_OpenID(ByRef hDevID As Integer, ByRef brdid As Integer) As Integer
		Dim hDev As Integer
		Dim n As Integer
		Dim ret As Integer
		Dim cnt As Integer
		Dim hInf(16) As HPCDEVICEINFO
		Dim hInf2 As HPCDEVICEINFO

		'{[h擾
		ret = ct520_GetDeviceCount(cnt)

		'{[h 0,17ȏ ܂ ߂l "0" ̎G[
		If ((cnt = 0) Or (cnt > CNTMAX) Or (ret <> 0)) Then
			sct520_OpenID = &H1000
			Exit Function
		End If

		'foCX擾
		ret = ct520_GetDeviceInfo(cnt, hInf(0))
		If (ret) Then
			sct520_OpenID = &H2000
			Exit Function
		End If

		' {[hIDw
		For n = 0 To cnt - 1
			If (hInf(n).dwBoardID = brdid) Then
				hInf2 = hInf(n)
				Exit For
			Else
				hInf2.dwBoardID = hInf(n).dwBoardID
			End If
		Next

		If hInf2.dwBoardID <> brdid Then
			sct520_OpenID = &H4000
			Exit Function
		End If

		ret = ct520_OpenDevice(hDev, hInf2)
		If (ret) Then
			ret = ct520_CloseDevice(hDev)
			hDev = -1
			sct520_OpenID = &H8000
		Else
			hDevID = hDev
			sct520_OpenID = 0
		End If
	End Function


	'***********************************************************
	'  {[h̏
	'      HPCI-CTR520F̏܂B
	'      gpɍ킹ēKXf[^ύXĂB
	'***********************************************************
	Public Function sct520_InitCtr(ByRef hDevID As Integer) As Integer
		Dim ret As Integer
		Dim reg As Integer

		' 1. #1CCLWX^ݒ
		' 1.1 \tgEFAZbg : ĳؾĎw߂őSĂڼ޽͂Oر
		ret = ct520_wXYCmd(hDevID, &H40S) ' ȍ~̊eڼ޽̏͊mF

		' 1.2 #1CCL WX^P(͎dl,̑)
		Const RENV1 As Integer = &HACC3012 ' WX^Pݒl
		' b31   (0   ):ϒ[qo:_(ްގd:Œ)
		' b30-28( 000):Ϗo͎FȂ
		' b27   (1   ):ڰ4:YCTR
		' b26   ( 0  ):ڰ3:XCTR
		' b25   (  1 ):ڰ2:YCTR
		' b24   (   0):ڰ1:XCTR
		' b23-21(110 ):DSBnͶĒ~:  (ްގdl:Œ)
		' b20   (   0):LTCn͘_=贯(ްގdl:Œ)
		' b19   (1   ):YZͶر:
		' b18   ( 1  ):XZͶر:
		' b17-16(  00):YZ,XZ͸ر:贯
		' b15   (0   ):YCTRǏo̎ر:Ȃ
		' b14   ( 0  ):XCTRǏo̎ر:Ȃ
		' b13   (  1 ):YCTR~
		' b12   (   1):XCTR~
		' b11-10(00  ):YCTRފԑI(`)
		' b 9- 8(  00):YCTRފԑJn(`)
		' b 7   (0   ):YCTR:޳ݶ
		' b 6   ( 0  ):YCTR=YA,YB
		' b 5- 3( 010):YA,YB=90߈ʑS{
		' b 2- 0( 010):XA,XB=90߈ʑS{
		ret = ct520_wXYReg(hDevID, &H87S, RENV1)
		ret = ct520_rXYReg(hDevID, &HC7S, reg) '  ƍǍ
		If (reg <> RENV1) Then
			sct520_InitCtr = 1
			Exit Function
		End If

		' 1.3 #1CCL WX^Q(ڰ,̑)
		Const RENV2 As Integer = &H1005FF00 ' WX^Qݒl
		' b31-30(00  ):(CCLdl)
		' b29   (  0 ):XA,XB,YA,YB̨nm
		' b28   (   1):CMPOUT1,2o:Ͻ()
		' b27-24(0000):P0-3[q=ėp(ްގdl:Œ)
		' b23   (0   ):CMPOUT3,4[qo͘_=_
		' b22   ( 0  ):CMPOUT1,2[qo͘_=_
		' b21   (  0 ):CMPOUT2o͂"="r=Ȃ
		' b20   (   0):CMPOUT1o͂"="r=Ȃ
		' b19-18(01  ):CMPOUT3,4o͐Mٽ=ݼ50us
		' b17-16(  01):CMPOUT1,2o͐Mٽ=ݼ50us
		' b15-12(1111):CMPOUT4o͂̔r@=ɕs
		' b11- 8(1111):CMPOUT3o͂̔r@=ɕs
		' b 7- 4(0000):CMPOUT2o͂̔r@=RCMP1<r
		' b 3- 0(0000):CMPOUT1o͂̔r@=RCMP1<r
		ret = ct520_wXYReg(hDevID, &H88S, RENV2)
		ret = ct520_rXYReg(hDevID, &HC8S, reg) '  ƍǍ
		If (reg <> RENV2) Then
			sct520_InitCtr = 1
			Exit Function
		End If

		' 1.4 #1CCL JE^P
		ret = ct520_wXYReg(hDevID, &H80S, 0) ' JE^PO
		ret = ct520_rXYReg(hDevID, &HC0S, reg) '  ƍǍ
		If (reg) Then
			sct520_InitCtr = 1
			Exit Function
		End If

		' 1.5 #1CCL JE^Q
		ret = ct520_wXYReg(hDevID, &H81S, 0) ' JE^QO
		ret = ct520_rXYReg(hDevID, &HC1S, reg) '  ƍǍ
		If (reg) Then
			sct520_InitCtr = 1
			Exit Function
		End If

		' 1.6 #1CCL rf[^WX^P
		Const WIND_N As Integer = -5000 ' ޺ڰ:RCMP1
		ret = ct520_wXYReg(hDevID, &H82S, WIND_N) ' rf[^WX^P= WIND_N
		ret = ct520_rXYReg(hDevID, &HC2S, reg) '  ƍǍ
		If (reg <> WIND_N) Then
			sct520_InitCtr = 1
			Exit Function
		End If

		' 1.7 #1CCL rf[^WX^Q
		Const WIND_P As Integer = 5000 ' ޺ڰ:RCMP2
		ret = ct520_wXYReg(hDevID, &H83S, WIND_P) ' rf[^WX^Q= WIND_P
		ret = ct520_rXYReg(hDevID, &HC3S, reg) '  ƍǍ
		If (reg <> WIND_P) Then
			sct520_InitCtr = 1
			Exit Function
		End If

		' 1.8 #1CCL rf[^WX^R
		ret = ct520_wXYReg(hDevID, &H84S, 0) ' rf[^WX^RO
		ret = ct520_rXYReg(hDevID, &HC4S, reg) '  ƍǍ
		If (reg) Then
			sct520_InitCtr = 1
			Exit Function
		End If

		' 1.9 #1CCL rf[^WX^S
		ret = ct520_wXYReg(hDevID, &H85S, 0) ' rf[^WX^SO
		ret = ct520_rXYReg(hDevID, &HC5S, reg) '  ƍǍ
		If (reg) Then
			sct520_InitCtr = 1
			Exit Function
		End If

		' 1.10 #1CCL Cxg^C}WX^
		ret = ct520_wXYReg(hDevID, &H86S, 0) ' Cxg^C}WX^O
		ret = ct520_rXYReg(hDevID, &HC6S, reg) '  ƍǍ
		If (reg) Then
			sct520_InitCtr = 1
			Exit Function
		End If

		' 1.11 #1CCL vݒ背WX^
		' b31-28(0000):sgp
		' b27   (0   ):sgp
		' b26   ( 0  ):(ITM):gpJnƎw莞Ԍoߖ
		' b25   (  0 ):YCTR:MaxMin蒆(=&H4a)ɑIތo(RENV1:b11-10)
		' b24   (   0):߼߰ēׯ(&H18)ݒɂ铯ׯ
		' b23   (0   ):YCTR -ް۰
		' b22   ( 0  ):YCTR +ް۰
		' b21   (  0 ):XCTR -ް۰
		' b20   (   0):XCTR +ް۰
		' b19   (0   ):YAYB͐Mُ픭(ω)
		' b18   ( 0  ):XAXB͐Mُ픭(ω)
		' b17   (  0 ):YCTR<>0 ==> YCTR=0
		' b16   (   0):XCTR<>0 ==> XCTR=0
		' b15-12(0000):sgp(\)
		' b11-10(00  ):sgp(\)
		' b 9   (  0 ):߼߰YZر(&H19:b1)ݒɂ鶳ر
		' b 8   (   0):߼߰XZر(&H19:b0)ݒɂ鶳ر
		' b 7   (0   ):CMPOUT4o͏  ==>s
		' b 6   ( 0  ):CMPOUT4o͏s==>  
		' b 5   (  0 ):CMPOUT3o͏  ==>s
		' b 4   (   0):CMPOUT3o͏s==>  
		' b 3   (0   ):CMPOUT2o͏  ==>s
		' b 2   ( 0  ):CMPOUT2o͏s==>  
		' b 1   (  0 ):CMPOUT1o͏  ==>s
		' b 0   (   0):CMPOUT1o͏s==>  
		ret = ct520_wXYReg(hDevID, &H89S, 0) '  all off
		ret = ct520_rXYReg(hDevID, &HC9S, reg) '  ƍǍ
		If (reg) Then
			sct520_InitCtr = 1
			Exit Function
		End If

		ret = ct520_wZUReg(hDevID, &H87S, &H1000S)
		ret = ct520_rZUReg(hDevID, &HC7S, reg) '  ƍǍ
		If (reg = &H1000S) Then ' SȂ
			' 2. #2CCLWX^ݒ
			' 2.1 \tgEFAZbg : ĳؾĎw߂őSĂڼ޽͂Oر
			ret = ct520_wZUCmd(hDevID, &H40S) ' ȍ~̊eڼ޽̏͊mF

			' 2.2 #2CCL WX^P(͎dl,̑)
			' #1CCLƓl̐ݒ
			ret = ct520_wZUReg(hDevID, &H87S, RENV1)
			ret = ct520_rZUReg(hDevID, &HC7S, reg) '  ƍǍ
			If (reg <> RENV1) Then
				sct520_InitCtr = 1
				Exit Function
			End If

			' 2.3 #2CCL WX^Q(ڰ,̑)
			' #1CCLƓl̐ݒ
			ret = ct520_wZUReg(hDevID, &H88S, RENV2)
			ret = ct520_rZUReg(hDevID, &HC8S, reg) '  ƍǍ
			If (reg <> RENV2) Then
				sct520_InitCtr = 1
				Exit Function
			End If

			' 2.4 #2CCL JE^P
			ret = ct520_wZUReg(hDevID, &H80S, 0) ' JE^PO
			ret = ct520_rZUReg(hDevID, &HC0S, reg) '  ƍǍ
			If (reg) Then
				sct520_InitCtr = 1
				Exit Function
			End If

			' 2.5 #2CCL JE^Q
			ret = ct520_wZUReg(hDevID, &H81S, 0) ' JE^QO
			ret = ct520_rZUReg(hDevID, &HC1S, reg) '  ƍǍ
			If (reg) Then
				sct520_InitCtr = 1
				Exit Function
			End If

			' 2.6 #2CCL rf[^WX^P
			' #1CCLƓl̐ݒ
			ret = ct520_wZUReg(hDevID, &H82S, WIND_N) ' rf[^WX^P= WIND_N
			ret = ct520_rZUReg(hDevID, &HC2S, reg) '  ƍǍ
			If (reg <> WIND_N) Then
				sct520_InitCtr = 1
				Exit Function
			End If

			' 2.7 #2CCL rf[^WX^Q
			' #1CCLƓl̐ݒ
			ret = ct520_wZUReg(hDevID, &H83S, WIND_P) ' rf[^WX^Q= WIND_P
			ret = ct520_rZUReg(hDevID, &HC3S, reg) '  ƍǍ
			If (reg <> WIND_P) Then
				sct520_InitCtr = 1
				Exit Function
			End If

			' 2.8 #2CCL rf[^WX^R
			ret = ct520_wZUReg(hDevID, &H84S, 0) ' rf[^WX^RO
			ret = ct520_rZUReg(hDevID, &HC4S, reg) '  ƍǍ
			If (reg) Then
				sct520_InitCtr = 1
				Exit Function
			End If

			' 2.9 #2CCL rf[^WX^S
			ret = ct520_wZUReg(hDevID, &H85S, 0) ' rf[^WX^SO
			ret = ct520_rZUReg(hDevID, &HC5S, reg) '  ƍǍ
			If (reg) Then
				sct520_InitCtr = 1
				Exit Function
			End If

			' 2.10 #2CCL Cxg^C}WX^
			ret = ct520_wZUReg(hDevID, &H86S, 0) ' Cxg^C}WX^O
			ret = ct520_rZUReg(hDevID, &HC6S, reg) '  ƍǍ
			If (reg) Then
				sct520_InitCtr = 1
				Exit Function
			End If

			' 2.11 #2CCL vݒ背WX^
			ret = ct520_wZUReg(hDevID, &H89S, 0) '  all off
			ret = ct520_rZUReg(hDevID, &HC9S, reg) '  ƍǍ
			If (reg) Then
				sct520_InitCtr = 1
				Exit Function
			End If
		End If

		' 3. o̓|[g & IvV|[gݒ
		ret = sct520_InitOpt(hDevID)
		If (ret) Then ' error
			sct520_InitCtr = 1
		Else
			sct520_InitCtr = 0
		End If
	End Function

	'*********************************************************
	'  o̓|[gƃIvV|[g̏
	'      HPCI-CTR520F̃IvV|[g̏܂B
	'      gpɍ킹ēKXf[^ύXĂB
	'*********************************************************
	Public Function sct520_InitOpt(ByRef hDevID As Integer) As Integer
		Dim bdt As Byte
		Dim wdt As Short
		Dim ret As Integer

		' o̓|[g & IvV|[gݒ
		' 1 ėpo̓|[gNA
		ret = ct520_wPortB(hDevID, OUT_PORT, 0) ' write(0)
		ret = ct520_rPortB(hDevID, OUT_PORT, bdt) '  ƍǍ
		bdt = bdt And &HFS ' mask
		If (bdt) Then ' verify error
			sct520_InitOpt = 1
			Exit Function
		End If

		' 2 CMPo͐ݒ|[gFo͂Ȃ
		ret = ct520_wPortW(hDevID, CMP_PORT, 0) ' write(0)
		ret = ct520_rPortW(hDevID, CMP_PORT, wdt) '  ƍǍ
		wdt = wdt And &HFFS ' mask
		If (wdt) Then ' verify error
			sct520_InitOpt = 1
			Exit Function
		End If

		' 3 TMRo͐ݒ|[gFo͂Ȃ
		ret = ct520_wPortW(hDevID, TMR_PORT, 0) ' write(0)
		ret = ct520_rPortW(hDevID, TMR_PORT, wdt) '  ƍǍ
		wdt = wdt And &H33S ' mask
		If (wdt) Then ' verify error
			sct520_InitOpt = 1
			Exit Function
		End If

		' 4 vo͐ݒ|[g(XYOUT1, ZUOUT1o͕104msec)
		ret = ct520_wPortW(hDevID, CIN_PORT, &H30S) ' write
		ret = ct520_rPortW(hDevID, CIN_PORT, wdt) '  ƍǍ
		wdt = wdt And &HFFS ' mask
		If (wdt <> &H30S) Then ' verify error
			sct520_InitOpt = 1
			Exit Function
		End If

		' 5 JE^NAݒ|[gݒFy͂ɂJE^NAȂ
		ret = ct520_wPortW(hDevID, CLR_PORT, 0) ' write
		ret = ct520_rPortW(hDevID, CLR_PORT, wdt) '  ƍǍ
		wdt = wdt And &HFS ' mask
		If (wdt) Then ' verify error
			sct520_InitOpt = 1
			Exit Function
		End If

		' 6 b`ݒ|[gݒFb`Ȃ
		ret = ct520_wPortW(hDevID, LTC_PORT, 0) ' write
		ret = ct520_rPortW(hDevID, LTC_PORT, wdt) '  ƍǍ
		wdt = wdt And &HFFS ' mask
		If (wdt) Then ' verify error
			sct520_InitOpt = 1
			Exit Function
		End If

		' 7 }XN()
		ret = ct520_wPortW(hDevID, INT_PORT, 0) ' write
		ret = ct520_rPortW(hDevID, INT_PORT, wdt) '  ƍǍ
		wdt = wdt And &H7S ' mask
		If (wdt) Then ' verify error
			sct520_InitOpt = 1
			Exit Function
		End If

		' 8 }XN(PCI)
		ret = ct520_wPortW(hDevID, PCI_PORT, 0) ' write
		ret = ct520_rPortW(hDevID, PCI_PORT, wdt) '  ƍǍ
		wdt = wdt And &H1S ' mask
		If (wdt) Then ' verify error
			sct520_InitOpt = 1
		Else
			sct520_InitOpt = 0
		End If
	End Function

	'**************************************************
	' JE^͌`̑I
	'   hDevID FfoCXnh
	'   ch   F`l(0:Xch, 1:Ych, 2:Zch, 3:Uch)
	'   md   FJE^͌`(O`T)
	'           0:x1, 1:x2, 2:x4, 3:U/D, 5:ٽ
	'      ڼ޽P: Ych(Uch)=b5-b3,Xch(Zch)=b2-b0
	'**************************************************
	Public Sub sct520_SelCtrMode(ByRef hDevID As Integer, ByRef ch As Short, ByRef md As Short)
		Dim reg As Integer
		Dim ret As Integer

		If ch < 2 Then
			ret = ct520_rXYReg(hDevID, &HC7S, reg) ' WX^P
			If ch = X_CH Then
				reg = reg And (Not &H7S)
				reg = reg Or md ' b2-b0
			Else
				reg = reg And (Not &H38S)
				reg = reg Or (md * 8) ' b5-b3
			End If
			ret = ct520_wXYReg(hDevID, &H87S, reg) ' WX^P
		ElseIf ch < 4 Then
			ret = ct520_rZUReg(hDevID, &HC7S, reg) ' WX^P
			If ch = Z_CH Then
				reg = reg And (Not &H7S)
				reg = reg Or md ' b2-b0
			Else
				reg = reg And (Not &H38S)
				reg = reg Or md * 8 ' b5-b3
			End If
			ret = ct520_wZUReg(hDevID, &H87S, reg) ' WX^P
		End If
	End Sub

	'**************************************************
	' JE^ǏõJE^NAݒ
	'   @\ FJE^Ǐo, JE^NA܂B
	'   hDevID FfoCXnh
	'   ch   F`l(0:Xch, 1:Ych, 2:Zch, 3:Uch)
	'   sel  FJE^NA(1) / Ȃ(0)
	'      ڼ޽P: Ych,Uch=b15,Xch,Zch=b14
	'**************************************************
	Public Sub sct520_SetAutoClr(ByRef hDevID As Integer, ByRef ch As Short, ByRef sel As Short)
		Dim reg As Integer
		Dim ret As Integer

		If ch < 2 Then
			ret = ct520_rXYReg(hDevID, &HC7S, reg) ' WX^P
			If ch = X_CH Then
				If sel = 1 Then
					reg = reg Or &H4000S '  b14=1
				Else
					reg = reg And (Not &H4000S) '  b14=0
				End If
			Else
				If sel = 1 Then
					reg = reg Or 32768 '  b15=1
				Else
					reg = reg And (Not 32768) '  b15=0
				End If
			End If
			ret = ct520_wXYReg(hDevID, &H87S, reg) ' WX^P
		ElseIf ch < 4 Then
			ret = ct520_rZUReg(hDevID, &HC7S, reg) ' WX^P
			If ch = Z_CH Then
				If sel = 1 Then
					reg = reg Or &H4000S '  b14=1
				Else
					reg = reg And (Not &H4000S) '  b14=0
				End If
			Else
				If sel = 1 Then
					reg = reg Or 32768 '  b15=1
				Else
					reg = reg And (Not 32768) '  b15=0
				End If
			End If
			ret = ct520_wZUReg(hDevID, &H87S, reg) ' WX^P
		End If
	End Sub

	'**************************************************
	' JEgX^[g
	'   @\ FJEgJn܂B
	'   hDevID FfoCXnh
	'   ch   F`l(0:Xch, 1:Ych, 2:Zch, 3:Uch)
	'      ڼ޽P: Ych(Uch):b13=0, Xch(Zch):b12=0
	'**************************************************
	Public Sub sct520_StrtCtr(ByRef hDevID As Integer, ByRef ch As Short)
		Dim reg As Integer
		Dim ret As Integer

		If ch < 2 Then
			ret = ct520_rXYReg(hDevID, &HC7S, reg) ' WX^P
			If ch = X_CH Then
				reg = reg And (Not &H1000S) '  b12=0
			Else
				reg = reg And (Not &H2000S) '  b13=0
			End If
			ret = ct520_wXYReg(hDevID, &H87S, reg) ' WX^P
		ElseIf ch < 4 Then
			ret = ct520_rZUReg(hDevID, &HC7S, reg) ' WX^P
			If ch = Z_CH Then
				reg = reg And (Not &H1000S) '  b12=0
			Else
				reg = reg And (Not &H2000S) '  b13=0
			End If
			ret = ct520_wZUReg(hDevID, &H87S, reg) ' WX^P
		End If
	End Sub

	'**************************************************
	' JEgXgbv
	'   @\ FJEg~܂B
	'   hDevID FfoCXnh
	'   ch   F`l(0:Xch, 1:Ych, 2:Zch, 3:Uch)
	'      ڼ޽P: Ych,Uch=b13,Xch,Zch=b12
	'**************************************************
	Public Sub sct520_StopCtr(ByRef hDevID As Integer, ByRef ch As Short)
		Dim reg As Integer
		Dim ret As Integer

		If ch < 2 Then
			ret = ct520_rXYReg(hDevID, &HC7S, reg) ' WX^P
			If ch = X_CH Then
				reg = reg Or &H1000S '  b12=1
			Else
				reg = reg Or &H2000S '  b13=1
			End If
			ret = ct520_wXYReg(hDevID, &H87S, reg) ' WX^P
		ElseIf ch < 4 Then
			ret = ct520_rZUReg(hDevID, &HC7S, reg) ' WX^P
			If ch = Z_CH Then
				reg = reg Or &H1000S '  b12=1
			Else
				reg = reg Or &H2000S '  b13=1
			End If
			ret = ct520_wZUReg(hDevID, &H87S, reg) ' WX^P
		End If
	End Sub

	'**************************************************
	' JE^Ǎ
	'   @\ FJEgǍ݂܂B
	'   hDevID FfoCXnh
	'   ch   F`l(0:Xch, 1:Ych, 2:Zch, 3:Uch)
	'   ctr  FJE^̒l
	'    Ǎ Xch,Zch=&HC0, Ych,Uch=&HC1
	'**************************************************
	Public Sub sct520_ReadCtr(ByRef hDevID As Integer, ByRef ch As Short, ByRef ctr As Integer)
		Dim ret As Integer

		If ch < 2 Then
			ret = ct520_rXYReg(hDevID, &HC0S + ch, ctr) ' ڼ޽Ǎ
		ElseIf ch < 4 Then
			ret = ct520_rZUReg(hDevID, &HC0S + (ch - 2), ctr) ' ڼ޽Ǎ
		End If
	End Sub

	'**************************************************
	' b`f[^Ǎ
	'   @\ Fb`f[^Ǎ݂܂B
	'   hDevID FfoCXnh
	'   ch   F`l(0:Xch, 1:Ych, 2:Zch, 3:Uch)
	'   ltc  Fb`f[^̒l
	'    Ǎ Xch,Zch=&HCA, Ych,Uch=&HCB
	'**************************************************
	Public Sub sct520_ReadLtc(ByRef hDevID As Integer, ByRef ch As Short, ByRef ltc As Integer)
		Dim ret As Integer

		If ch < 2 Then
			ret = ct520_rXYReg(hDevID, &HCAS + ch, ltc) ' ڼ޽Ǎ
		ElseIf ch < 4 Then
			ret = ct520_rZUReg(hDevID, &HCAS + (ch - 2), ltc) ' ڼ޽Ǎ
		End If
	End Sub

	'**************************************************
	' őlf[^Ǎ
	'   @\ Főlf[^Ǎ݂܂B
	'   hDevID FfoCXnh
	'   ch   F`l(0:Xch, 1:Ych, 2:Zch, 3:Uch)
	'   max  Főlf[^̒l
	'    Ǎ Xch,Zch=&HCC, Ych,Uch=&HCE
	'**************************************************
	Public Sub sct520_ReadMax(ByRef hDevID As Integer, ByRef ch As Short, ByRef max As Integer)
		Dim ret As Integer

		If ch < 2 Then
			ret = ct520_rXYReg(hDevID, &HCCS + (ch * 2), max) ' ڼ޽Ǎ
		ElseIf ch < 4 Then
			ret = ct520_rZUReg(hDevID, &HCCS + ((ch - 2) * 2), max) ' ڼ޽Ǎ
		End If
	End Sub

	'**************************************************
	' ŏlf[^Ǎ
	'   @\ Fŏlf[^Ǎ݂܂B
	'   hDevID FfoCXnh
	'   ch   F`l(0:Xch, 1:Ych, 2:Zch, 3:Uch)
	'   min  Fŏlf[^̒l
	'    Ǎ Xch,Zch=&HCD, Ych,Uch=&HCF
	'**************************************************
	Public Sub sct520_ReadMin(ByRef hDevID As Integer, ByRef ch As Short, ByRef min As Integer)
		Dim ret As Integer

		If ch < 2 Then
			ret = ct520_rXYReg(hDevID, &HCDS + (ch * 2), min) ' ڼ޽Ǎ
		ElseIf ch < 4 Then
			ret = ct520_rZUReg(hDevID, &HCDS + ((ch - 2) * 2), min) ' ڼ޽Ǎ
		End If
	End Sub

	'**************************************************
	' JE^NA
	'   @\ FJE^NA(=0)܂B
	'   hDevID FfoCXnh
	'   ch   F`l(0:Xch, 1:Ych, 2:Zch, 3:Uch)
	'     Xch,Zch=&H1, Ych,Uch=&H2
	'**************************************************
	Public Sub sct520_ClrCtr(ByRef hDevID As Integer, ByRef ch As Short)
		Dim ret As Integer

		If ch < 2 Then
			ret = ct520_wXYCmd(hDevID, ch + 1) ' Pƺޏ
		ElseIf ch < 4 Then
			ret = ct520_wZUCmd(hDevID, ch - 1) ' Pƺޏ
		End If
	End Sub

	'**************************************************
	' MaxMin
	'   @\ Főlŏl(=݂̃JEgl)
	'   hDevID FfoCXnh
	'   ch   F`l(0:Xch, 1:Ych, 2:Zch, 3:Uch)
	'     Xch,Zch=&H4, Ych,Uch=&H8
	'**************************************************
	Public Sub sct520_InitMM(ByRef hDevID As Integer, ByRef ch As Short)
		Dim ret As Integer

		If ch < 2 Then
			ret = ct520_wXYCmd(hDevID, 4 + (ch * 4)) ' Pƺޏ
		ElseIf ch < 4 Then
			ret = ct520_wZUCmd(hDevID, 4 + ((ch - 2) * 4)) ' Pƺޏ
		End If
	End Sub

	'**************************************************
	' MaxMinJn
	'   @\ FMaxMinJn܂B
	'   hDevID FfoCXnh
	'   ch   F`l(0:Xch, 1:Ych, 2:Zch, 3:Uch)
	'     Xch,Zch=&H48, Ych,Uch=&H4A
	'**************************************************
	Public Sub sct520_StrtMM(ByRef hDevID As Integer, ByRef ch As Short)
		Dim ret As Integer

		If ch < 2 Then
			ret = ct520_wXYCmd(hDevID, &H48S + (ch * 2)) ' Pƺޏ
		ElseIf ch < 4 Then
			ret = ct520_wZUCmd(hDevID, &H48S + ((ch - 2) * 2)) ' Pƺޏ
		End If
	End Sub

	'**************************************************
	' MaxMinI
	'   @\ FMaxMinI܂B
	'   hDevID FfoCXnh
	'   ch   F`l(0:Xch, 1:Ych, 2:Zch, 3:Uch)
	'     Xch,Zch=&H49, Ych,Uch=&H4B
	'**************************************************
	Public Sub sct520_StopMM(ByRef hDevID As Integer, ByRef ch As Short)
		Dim ret As Integer

		If ch < 2 Then
			ret = ct520_wXYCmd(hDevID, &H49S + (ch * 2)) ' Pƺޏ
		ElseIf ch < 4 Then
			ret = ct520_wZUCmd(hDevID, &H49S + ((ch - 2) * 2)) ' Pƺޏ
		End If
	End Sub
End Module