/************************************/
/*  HPCI-CTR520F series sample(Vc)	*/
/*	    file name:h_cmp.c			*/
/*      date     :2003/02/20		*/
/*      version  :1.1.0.0 			*/
/*		2010/06/07 Rp[^ */
/*      @@@@@ \C			*/
/************************************/

#include	<windows.h>
#include	"resource.h"
#include	"hictr520.h"
#include	"spct5200.h"

void	DlgCmpLoad  (HWND);
void	DlgCmpUnload(HWND);
void	OpenCmpDev  (HWND);		/* foCXI[v */
void	CloseCmpDev (HWND);		/* foCXN[Y */
void	TmrReadCmp  (HWND);		/* JE^Ǎ^C} */
void	SetCmpData	(HWND);		/* Rp[^̐ݒ */
void	SetCmpText  (HWND);		/* Rp[^\ */

/*	foCX֌W̃_CAO{bNX  */
BOOL CALLBACK DlgCmpProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	LPARAM	dummy;
	long	reg;
	char	szBuf[255];
	WORD	sts;

	dummy = lParam;

	/* _CAO{bNX */
	switch(message) {
		/*  */
		case WM_SHOWWINDOW:	DlgCmpLoad(hwnd);					break;

		/* {^NbN̏ */
		case WM_COMMAND:
			switch (LOWORD(wParam)) {
				/* foCXI[v */
				case IDC_BTN_OPEN:	OpenCmpDev(hwnd);			break;

				/* foCXN[Y */
				case IDC_BTN_CLOS:	CloseCmpDev(hwnd);			break;

				case IDC_BTN_XREAD:	
					sct520_ReadCtr(hDev, X_CH, &reg);
					/* \ */
					wsprintf(szBuf, "%ld ", reg);
					SetDlgItemText(hwnd, IDC_STA_XCTR, szBuf);
																break;
				case IDC_BTN_YREAD:	
					sct520_ReadCtr(hDev, Y_CH, &reg);
					/* \ */
					wsprintf(szBuf, "%ld ", reg);
					SetDlgItemText(hwnd, IDC_STA_YCTR, szBuf);
																break;
				case IDC_BTN_XCLR:	
					sct520_ClrCtr (hDev, X_CH);		
					sct520_ReadCtr(hDev, X_CH, &reg);
					/* \ */
					wsprintf(szBuf, "%ld ", reg);
					SetDlgItemText(hwnd, IDC_STA_XCTR, szBuf);
																break;
				case IDC_BTN_YCLR:
					sct520_ClrCtr (hDev, Y_CH);		
					sct520_ReadCtr(hDev, Y_CH, &reg);
					/* \ */
					wsprintf(szBuf, "%ld ", reg);
					SetDlgItemText(hwnd, IDC_STA_YCTR, szBuf);
																break;
				case IDC_BTN_XSTA:
					/* Xe[^XǍ */
					ct520_rXYSts(hDev, &sts);
					if(sts & 0x20) { 
						SetCmpData(hwnd);
					}
					sct520_StrtCtr(hDev, X_CH);	
					EnableWindow(GetDlgItem(hwnd, IDC_STA_SLOP),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_STA_SLRD),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT1),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT2),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT4),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_UPDN),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_DIRC),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_MANU),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_AUTO),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_CHK_AUTO),  FALSE);
		
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP10),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP11),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP12),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP13),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP14),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP15),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP16),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP17),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP18),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP19),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP1A),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP1B),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP1C),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP1D),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP1E),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP1F),  FALSE);

					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP30),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP31),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP32),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP33),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP34),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP35),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP36),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP37),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP38),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP39),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP3A),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP3B),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP3C),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP3D),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP3E),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP3F),  FALSE);

					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP1X),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP1Y),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP2X),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP2Y),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP3X),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP3Y),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP4X),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP4Y),  FALSE);

					EnableWindow(GetDlgItem(hwnd, IDC_RAD_WDT1),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_WDT2),  FALSE);


					EnableWindow(GetDlgItem(hwnd, IDC_EDT_RCM1),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_EDT_RCM2),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_EDT_RCM3),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_EDT_RCM4),  FALSE);

					EnableWindow(GetDlgItem(hwnd, IDC_STA_RCM1),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_STA_RCM2),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_STA_RCM3),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_STA_RCM4),  FALSE);

					EnableWindow(GetDlgItem(hwnd, IDC_STA_CMP1),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_STA_CMP3),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_STA_SLOT),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_STA_SLWD),  FALSE);

					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CMP1),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CMP3),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_BTN_XSTP),  TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_BTN_XSTA),  FALSE);
																break;
				case IDC_BTN_YSTA:
					/* Xe[^XǍ */
					ct520_rXYSts(hDev, &sts);
					if(sts & 0x10) { 
						SetCmpData(hwnd);
					}
					sct520_StrtCtr(hDev, Y_CH);	
					EnableWindow(GetDlgItem(hwnd, IDC_STA_SLOP),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_STA_SLRD),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT1),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT2),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT4),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_UPDN),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_DIRC),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_MANU),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_AUTO),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_CHK_AUTO),  FALSE);
					
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP10),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP11),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP12),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP13),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP14),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP15),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP16),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP17),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP18),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP19),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP1A),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP1B),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP1C),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP1D),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP1E),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP1F),  FALSE);

					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP30),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP31),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP32),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP33),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP34),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP35),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP36),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP37),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP38),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP39),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP3A),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP3B),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP3C),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP3D),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP3E),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP3F),  FALSE);

					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP1X),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP1Y),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP2X),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP2Y),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP3X),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP3Y),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP4X),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP4Y),  FALSE);

					EnableWindow(GetDlgItem(hwnd, IDC_RAD_WDT1),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_WDT2),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_EDT_RCM1),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_EDT_RCM2),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_EDT_RCM3),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_EDT_RCM4),  FALSE);

					EnableWindow(GetDlgItem(hwnd, IDC_STA_RCM1),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_STA_RCM2),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_STA_RCM3),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_STA_RCM4),  FALSE);

					EnableWindow(GetDlgItem(hwnd, IDC_STA_CMP1),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_STA_CMP3),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_STA_SLOT),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_STA_SLWD),  FALSE);

					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CMP1),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CMP3),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_BTN_YSTP),  TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_BTN_YSTA),  FALSE);
																break;
				case IDC_BTN_XSTP:	
					sct520_StopCtr(hDev, X_CH);	
					EnableWindow(GetDlgItem(hwnd, IDC_BTN_XSTP),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_BTN_XSTA),  TRUE);
																break;
				case IDC_BTN_YSTP:	
					sct520_StopCtr(hDev, Y_CH);	
					EnableWindow(GetDlgItem(hwnd, IDC_BTN_YSTP),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_BTN_YSTA),  TRUE);
																break;
				case IDC_RAD_MLT1:	
					sct520_SelCtrMode(hDev, X_CH, MLT1_NO);
					sct520_SelCtrMode(hDev, Y_CH, MLT1_NO);
																break;
				case IDC_RAD_MLT2:
					sct520_SelCtrMode(hDev, X_CH, MLT2_NO);
					sct520_SelCtrMode(hDev, Y_CH, MLT2_NO);
																break;
				case IDC_RAD_MLT4:
					sct520_SelCtrMode(hDev, X_CH, MLT4_NO);
					sct520_SelCtrMode(hDev, Y_CH, MLT4_NO);
																break;
				case IDC_RAD_UPDN:
					sct520_SelCtrMode(hDev, X_CH, UPDN_NO);
					sct520_SelCtrMode(hDev, Y_CH, UPDN_NO);
																break;
				case IDC_RAD_DIRC:
					sct520_SelCtrMode(hDev, X_CH, DIRC_NO);
					sct520_SelCtrMode(hDev, Y_CH, DIRC_NO);
																break;
				case IDC_RAD_MANU:
					if(IsDlgButtonChecked(hwnd, IDC_RAD_MANU) == BST_CHECKED) {
						EnableWindow(GetDlgItem(hwnd, IDC_BTN_XREAD), TRUE);
						EnableWindow(GetDlgItem(hwnd, IDC_BTN_YREAD), TRUE);
					}
																break;
				case IDC_RAD_AUTO:
					if(IsDlgButtonChecked(hwnd, IDC_RAD_AUTO) == BST_CHECKED) {
						EnableWindow(GetDlgItem(hwnd, IDC_BTN_XREAD), FALSE);
						EnableWindow(GetDlgItem(hwnd, IDC_BTN_YREAD), FALSE);
					}
																break;
				case IDC_CHK_AUTO:	
					if(IsDlgButtonChecked(hwnd, IDC_CHK_AUTO) == BST_CHECKED) {
						sct520_SetAutoClr(hDev, X_CH, 1);
						sct520_SetAutoClr(hDev, Y_CH, 1);
					} else {
						sct520_SetAutoClr(hDev, X_CH, 0);
						sct520_SetAutoClr(hDev, Y_CH, 0);
					}
																break;
				case IDC_RAD_CMP1:
					EnableWindow(GetDlgItem(hwnd, IDC_STA_CMP1),  TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP10),  TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP11),  TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP12),  TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP13),  TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP14),  TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP15),  TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP16),  TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP17),  TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP18),  TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP19),  TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP1A),  TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP1B),  TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP1C),  TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP1D),  TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP1E),  TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP1F),  TRUE);

					EnableWindow(GetDlgItem(hwnd, IDC_STA_CMP3),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP30),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP31),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP32),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP33),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP34),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP35),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP36),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP37),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP38),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP39),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP3A),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP3B),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP3C),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP3D),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP3E),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP3F),  FALSE);

					CheckDlgButton(hwnd, IDC_RAD_CP10, BST_CHECKED);

					CheckDlgButton(hwnd, IDC_RAD_CP30, BST_UNCHECKED);
					CheckDlgButton(hwnd, IDC_RAD_CP31, BST_UNCHECKED);
					CheckDlgButton(hwnd, IDC_RAD_CP32, BST_UNCHECKED);
					CheckDlgButton(hwnd, IDC_RAD_CP33, BST_UNCHECKED);
					CheckDlgButton(hwnd, IDC_RAD_CP34, BST_UNCHECKED);
					CheckDlgButton(hwnd, IDC_RAD_CP35, BST_UNCHECKED);
					CheckDlgButton(hwnd, IDC_RAD_CP36, BST_UNCHECKED);
					CheckDlgButton(hwnd, IDC_RAD_CP37, BST_UNCHECKED);
					CheckDlgButton(hwnd, IDC_RAD_CP38, BST_UNCHECKED);
					CheckDlgButton(hwnd, IDC_RAD_CP39, BST_UNCHECKED);
					CheckDlgButton(hwnd, IDC_RAD_CP3A, BST_UNCHECKED);
					CheckDlgButton(hwnd, IDC_RAD_CP3B, BST_UNCHECKED);
					CheckDlgButton(hwnd, IDC_RAD_CP3C, BST_UNCHECKED);
					CheckDlgButton(hwnd, IDC_RAD_CP3D, BST_UNCHECKED);
					CheckDlgButton(hwnd, IDC_RAD_CP3E, BST_UNCHECKED);
					CheckDlgButton(hwnd, IDC_RAD_CP3F, BST_UNCHECKED);
																break;
				case IDC_RAD_CMP3:
					EnableWindow(GetDlgItem(hwnd, IDC_STA_CMP1),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP10),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP11),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP12),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP13),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP14),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP15),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP16),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP17),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP18),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP19),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP1A),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP1B),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP1C),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP1D),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP1E),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP1F),  FALSE);

					EnableWindow(GetDlgItem(hwnd, IDC_STA_CMP3),  TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP30),  TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP31),  TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP32),  TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP33),  TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP34),  TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP35),  TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP36),  TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP37),  TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP38),  TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP39),  TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP3A),  TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP3B),  TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP3C),  TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP3D),  TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP3E),  TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP3F),  TRUE);
	
					CheckDlgButton(hwnd, IDC_RAD_CP10, BST_UNCHECKED);
					CheckDlgButton(hwnd, IDC_RAD_CP11, BST_UNCHECKED);
					CheckDlgButton(hwnd, IDC_RAD_CP12, BST_UNCHECKED);
					CheckDlgButton(hwnd, IDC_RAD_CP13, BST_UNCHECKED);
					CheckDlgButton(hwnd, IDC_RAD_CP14, BST_UNCHECKED);
					CheckDlgButton(hwnd, IDC_RAD_CP15, BST_UNCHECKED);
					CheckDlgButton(hwnd, IDC_RAD_CP16, BST_UNCHECKED);
					CheckDlgButton(hwnd, IDC_RAD_CP17, BST_UNCHECKED);
					CheckDlgButton(hwnd, IDC_RAD_CP18, BST_UNCHECKED);
					CheckDlgButton(hwnd, IDC_RAD_CP19, BST_UNCHECKED);
					CheckDlgButton(hwnd, IDC_RAD_CP1A, BST_UNCHECKED);
					CheckDlgButton(hwnd, IDC_RAD_CP1B, BST_UNCHECKED);
					CheckDlgButton(hwnd, IDC_RAD_CP1C, BST_UNCHECKED);
					CheckDlgButton(hwnd, IDC_RAD_CP1D, BST_UNCHECKED);
					CheckDlgButton(hwnd, IDC_RAD_CP1E, BST_UNCHECKED);
					CheckDlgButton(hwnd, IDC_RAD_CP1F, BST_UNCHECKED);

					CheckDlgButton(hwnd, IDC_RAD_CP3F, BST_CHECKED);
																break;
				case IDC_RAD_CP1X:	SetCmpText(hwnd);			break;
				case IDC_RAD_CP1Y:	SetCmpText(hwnd);			break;
				case IDC_RAD_CP2X:	SetCmpText(hwnd);			break;
				case IDC_RAD_CP2Y:	SetCmpText(hwnd);			break;
				case IDC_RAD_CP3X:	SetCmpText(hwnd);			break;
				case IDC_RAD_CP3Y:	SetCmpText(hwnd);			break;
				case IDC_RAD_CP4X:	SetCmpText(hwnd);			break;
				case IDC_RAD_CP4Y:	SetCmpText(hwnd);			break;
			}
																break;	
		/* ^C} */
		case WM_TIMER:
			switch(LOWORD(wParam)) {
				case IDM_TMR_READ:	TmrReadCmp(hwnd);			break;
			}
																break;		
		/* I */
		case WM_CLOSE:			DlgCmpUnload(hwnd);				break;

		/* I */	
		case WM_DESTROY:		hDlg = NULL;					break;
	}
	return 0;
}

	
/* foCXI[v */
void OpenCmpDev(HWND hwnd)
{
    char	szBuf[255];
	DWORD	ret;

	if(hDev == -1) {
        // {[hI[v
        ret = sct520_OpenID(&hDev, gBrdID);
		if(ret & 0x1000) {
			wsprintf(szBuf, "%s\n%s", "{[h擾s!", 
							"{[h}ĂȂAhCoCXg[ĂȂ̃G[");	
			MessageBox(hwnd, szBuf, "ErrorMessage", MB_OK);
			return;
		} else if(ret & 0x2000) {
			wsprintf(szBuf, "%s\n%s", "{[h擾s!", "VXes̃G[");	
			MessageBox(hwnd, szBuf, "ErrorMessage", MB_OK);
            return;
        } else if(ret & 0x4000) {
			wsprintf(szBuf, "%s%ld%s", "w肵{[hhc ", gBrdID, "̃{[h}Ă܂");
			MessageBox(hwnd, szBuf, "ErrorMessage", MB_OK);
            return;
		} else if(ret & 0x8000) {
			wsprintf(szBuf, "%s\n%s", "foCXI[vsF", "VXes̃G[");	
			MessageBox(hwnd, szBuf, "ErrorMessage", MB_OK);
			return;
		}
        
        // {[h̏
		ret = sct520_InitCtr(hDev);
		if(ret) {
			wsprintf(szBuf, "JE^[s!");	
			MessageBox(hwnd, szBuf, "ErrorMessage", MB_OK);
			DlgCmpUnload(hwnd);
			return;
		}

		/* {^\ */
		EnableWindow(GetDlgItem(hwnd, IDC_STA_XCH),   TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_YCH),   TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_0001),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_0002),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_BTN_XREAD), FALSE);
		EnableWindow(GetDlgItem(hwnd, IDC_BTN_YREAD), FALSE);
		EnableWindow(GetDlgItem(hwnd, IDC_BTN_XCLR),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_BTN_YCLR),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_BTN_XSTA),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_BTN_YSTA),  TRUE);

		EnableWindow(GetDlgItem(hwnd, IDC_STA_SLOP),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_SLRD),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT1),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT2),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT4),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_UPDN),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_DIRC),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_MANU),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_AUTO),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_CHK_AUTO),  TRUE);

		EnableWindow(GetDlgItem(hwnd, IDC_STA_RCM1),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_RCM2),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_RCM3),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_RCM4),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_0003),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_0004),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_0005),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_0006),  TRUE);

		EnableWindow(GetDlgItem(hwnd, IDC_EDT_RCM1),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_EDT_RCM2),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_EDT_RCM3),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_EDT_RCM4),  TRUE);

		EnableWindow(GetDlgItem(hwnd, IDC_STA_SLOT),  TRUE);

		EnableWindow(GetDlgItem(hwnd, IDC_RAD_CMP1),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_CMP3),  TRUE);

		EnableWindow(GetDlgItem(hwnd, IDC_STA_CMP1),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP10),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP11),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP12),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP13),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP14),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP15),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP16),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP17),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP18),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP19),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP1A),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP1B),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP1C),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP1D),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP1E),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP1F),  TRUE);

		EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP1X),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP1Y),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP2X),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP2Y),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP3X),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP3Y),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP4X),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP4Y),  TRUE);

		EnableWindow(GetDlgItem(hwnd, IDC_STA_SLWD),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_WDT1),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_WDT2),  TRUE);

		EnableWindow(GetDlgItem(hwnd, IDC_BTN_OPEN),  FALSE);	/* foCXI[v{^gps */
		EnableWindow(GetDlgItem(hwnd, IDC_BTN_CLOS),  TRUE);	/* foCXN[Y{^gp */

		/* WI{^`FbN */
		CheckDlgButton(hwnd, IDC_RAD_MLT4, BST_CHECKED);
		CheckDlgButton(hwnd, IDC_RAD_AUTO, BST_CHECKED);
		CheckDlgButton(hwnd, IDC_RAD_CP10, BST_CHECKED);
		CheckDlgButton(hwnd, IDC_RAD_CMP1, BST_CHECKED);
		CheckDlgButton(hwnd, IDC_RAD_CP1X, BST_CHECKED);
		CheckDlgButton(hwnd, IDC_RAD_CP2X, BST_CHECKED);
		CheckDlgButton(hwnd, IDC_RAD_CP3Y, BST_CHECKED);
		CheckDlgButton(hwnd, IDC_RAD_CP4Y, BST_CHECKED);
		CheckDlgButton(hwnd, IDC_RAD_WDT2, BST_CHECKED);

		/* GfBbg{bNX̕\ */
		SetDlgItemText(hwnd, IDC_EDT_RCM1,	"1000");
		SetDlgItemText(hwnd, IDC_EDT_RCM2,	"10000");
		SetDlgItemText(hwnd, IDC_EDT_RCM3,	"1000");
		SetDlgItemText(hwnd, IDC_EDT_RCM4,	"10000");

		SendDlgItemMessage(hwnd, IDC_EDT_RCM1, EM_SETLIMITTEXT, 7l, 0l);
		SendDlgItemMessage(hwnd, IDC_EDT_RCM2, EM_SETLIMITTEXT, 7l, 0l);
		SendDlgItemMessage(hwnd, IDC_EDT_RCM3, EM_SETLIMITTEXT, 7l, 0l);
		SendDlgItemMessage(hwnd, IDC_EDT_RCM4, EM_SETLIMITTEXT, 7l, 0l);

		SetCmpText(hwnd);

		SetTimer(hwnd, IDM_TMR_READ, 100, NULL);		/* ^C}Jn(100msec) */
	}
}

/* foCXN[Y */
void CloseCmpDev(HWND hwnd)
{
	DWORD	ret;

	if(hDev == -1)	return;
	
	KillTimer(hwnd, IDM_TMR_READ);						/* ^C}I */

	/* ʕ\ */
	CheckDlgButton(hwnd, IDC_RAD_MLT1, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_MLT2, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_MLT4, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_UPDN, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_DIRC, BST_UNCHECKED);

	CheckDlgButton(hwnd, IDC_RAD_MANU, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_AUTO, BST_UNCHECKED);

	CheckDlgButton(hwnd, IDC_CHK_AUTO, BST_UNCHECKED);

	CheckDlgButton(hwnd, IDC_RAD_CP10, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_CP11, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_CP12, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_CP13, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_CP14, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_CP15, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_CP16, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_CP17, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_CP18, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_CP19, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_CP1A, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_CP1B, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_CP1C, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_CP1D, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_CP1E, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_CP1F, BST_UNCHECKED);

	CheckDlgButton(hwnd, IDC_RAD_CP30, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_CP31, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_CP32, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_CP33, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_CP34, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_CP35, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_CP36, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_CP37, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_CP38, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_CP39, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_CP3A, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_CP3B, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_CP3C, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_CP3D, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_CP3E, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_CP3F, BST_UNCHECKED);

	CheckDlgButton(hwnd, IDC_RAD_CP1X, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_CP1Y, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_CP2X, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_CP2Y, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_CP3X, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_CP3Y, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_CP4X, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_CP4Y, BST_UNCHECKED);

	CheckDlgButton(hwnd, IDC_RAD_WDT1, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_WDT2, BST_UNCHECKED);

	CheckDlgButton(hwnd, IDC_RAD_CMP1, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_CMP3, BST_UNCHECKED);

	SendDlgItemMessage(hwnd, IDC_STA_XRUN, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL);
	SendDlgItemMessage(hwnd, IDC_STA_YRUN, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL);

	SetDlgItemText(hwnd, IDC_STA_XCTR, "");
	SetDlgItemText(hwnd, IDC_STA_YCTR, "");

	EnableWindow(GetDlgItem(hwnd, IDC_STA_XCH),   FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_YCH),   FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_0001),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_0002),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_BTN_XREAD), FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_BTN_YREAD), FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_BTN_XCLR),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_BTN_YCLR),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_BTN_XSTA),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_BTN_YSTA),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_BTN_XSTP),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_BTN_YSTP),  FALSE);

	EnableWindow(GetDlgItem(hwnd, IDC_STA_SLOP),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_SLRD),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT1),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT2),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT4),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_UPDN),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_DIRC),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_MANU),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_AUTO),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_CHK_AUTO),  FALSE);

	EnableWindow(GetDlgItem(hwnd, IDC_STA_RCM1),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_RCM2),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_RCM3),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_RCM4),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_0003),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_0004),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_0005),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_0006),  FALSE);

	EnableWindow(GetDlgItem(hwnd, IDC_EDT_RCM1),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_EDT_RCM2),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_EDT_RCM3),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_EDT_RCM4),  FALSE);

	EnableWindow(GetDlgItem(hwnd, IDC_STA_CMP1),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_CMP3),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_SLOT),  FALSE);

	EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP10),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP11),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP12),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP13),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP14),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP15),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP16),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP17),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP18),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP19),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP1A),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP1B),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP1C),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP1D),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP1E),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP1F),  FALSE);

	EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP30),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP31),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP32),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP33),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP34),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP35),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP36),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP37),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP38),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP39),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP3A),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP3B),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP3C),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP3D),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP3E),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP3F),  FALSE);

	EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP1X),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP1Y),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP2X),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP2Y),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP3X),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP3Y),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP4X),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP4Y),  FALSE);

	EnableWindow(GetDlgItem(hwnd, IDC_STA_SLWD),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_WDT1),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_WDT2),  FALSE);

	EnableWindow(GetDlgItem(hwnd, IDC_RAD_CMP1),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_CMP3),  FALSE);

	EnableWindow(GetDlgItem(hwnd, IDC_BTN_OPEN),  TRUE);	/* foCXI[v{^gp */
	EnableWindow(GetDlgItem(hwnd, IDC_BTN_CLOS),  FALSE);	/* foCXN[Y{^gps */

	/* GfBbg{bNX̕\ */
	SetDlgItemText(hwnd, IDC_EDT_RCM1,	"");
	SetDlgItemText(hwnd, IDC_EDT_RCM2,	"");
	SetDlgItemText(hwnd, IDC_EDT_RCM3,	"");
	SetDlgItemText(hwnd, IDC_EDT_RCM4,	"");
	
	ret = ct520_CloseDevice(hDev);

	/* foCXN[YςȂhDev=-1(foCXI[v^N[YԔf̈) */
	hDev = (DWORD)-1;
}

/* ʏ */
void DlgCmpLoad(HWND hwnd)
{
	HDC		hDC;
	
	/* w肳ꂽEBhẼNCAg̈ɑ΂foCXReLXg̃nh擾 */
	hDC = GetDC(hwnd);

	/* foCXReLXg */
	ReleaseDC(hwnd, hDC);

	/* rbg}bṽ[h */
	hWht  = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_WHITE));
	hGrn  = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_GREEN));

	hDev = (DWORD)-1;
}

/*	e_CAO鏈 */
void DlgCmpUnload(HWND hwnd)
{	
	if(hDev != -1) {
		KillTimer(hwnd, IDM_TMR_READ);	/* ^C}I */
		ct520_CloseDevice(hDev);		/* foCXN[Y */
		hDev = (DWORD)-1;				/* foCXN[YςȂhDev=-1(foCXI[v^N[YԔf̈) */
	}

	DestroyWindow(hwnd);				/* _CAO{bNX */
	hDlg = NULL;						/* _CAO{bNX̃nh */
	ShowWindow(hInx, SW_SHOWDEFAULT);	/* C̃EBhE\ */
}

/* JEglCb`f[^CXe[^XǍ */
void TmrReadCmp(HWND hwnd)
{
	char	szBuf[255];
	WORD	sts;
	long	reg;

	/* Xe[^XǍ */
	ct520_rXYSts(hDev, &sts);

	if((sts & 0x10) && (sts & 0x20)) {
		/* ~̎̓JEg͌`I */
		EnableWindow(GetDlgItem(hwnd, IDC_STA_SLOP), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_SLRD), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT1), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT2), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT4), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_UPDN), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_DIRC), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_MANU), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_AUTO), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_CHK_AUTO), TRUE);
	
		EnableWindow(GetDlgItem(hwnd, IDC_STA_SLOT), TRUE);
		
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_CMP1), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_CMP3), TRUE);

		EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP1X), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP1Y), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP2X), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP2Y), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP3X), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP3Y), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP4X), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP4Y), TRUE);

		EnableWindow(GetDlgItem(hwnd, IDC_RAD_WDT1), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_WDT2), TRUE);

		EnableWindow(GetDlgItem(hwnd, IDC_EDT_RCM1), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_EDT_RCM2), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_EDT_RCM3), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_EDT_RCM4), TRUE);

		EnableWindow(GetDlgItem(hwnd, IDC_STA_RCM1), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_RCM2), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_RCM3), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_RCM4), TRUE);

		EnableWindow(GetDlgItem(hwnd, IDC_STA_SLWD), TRUE);

		if(IsDlgButtonChecked(hwnd, IDC_RAD_CMP1) == BST_CHECKED) {
			EnableWindow(GetDlgItem(hwnd, IDC_STA_CMP1),  TRUE);
			EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP10),  TRUE);
			EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP11),  TRUE);
			EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP12),  TRUE);
			EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP13),  TRUE);
			EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP14),  TRUE);
			EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP15),  TRUE);
			EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP16),  TRUE);
			EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP17),  TRUE);
			EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP18),  TRUE);
			EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP19),  TRUE);
			EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP1A),  TRUE);
			EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP1B),  TRUE);
			EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP1C),  TRUE);
			EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP1D),  TRUE);
			EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP1E),  TRUE);
			EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP1F),  TRUE);
		} 
		
		if(IsDlgButtonChecked(hwnd, IDC_RAD_CMP3) == BST_CHECKED) {
			EnableWindow(GetDlgItem(hwnd, IDC_STA_CMP3),  TRUE);
			EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP30),  TRUE);
			EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP31),  TRUE);
			EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP32),  TRUE);
			EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP33),  TRUE);
			EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP34),  TRUE);
			EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP35),  TRUE);
			EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP36),  TRUE);
			EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP37),  TRUE);
			EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP38),  TRUE);
			EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP39),  TRUE);
			EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP3A),  TRUE);
			EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP3B),  TRUE);
			EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP3C),  TRUE);
			EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP3D),  TRUE);
			EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP3E),  TRUE);
			EnableWindow(GetDlgItem(hwnd, IDC_RAD_CP3F),  TRUE);
		}
	}

	if(IsDlgButtonChecked(hwnd, IDC_RAD_AUTO) == BST_CHECKED) {
		/* JEglǍ */
		sct520_ReadCtr(hDev, X_CH, &reg);
		/* \ */
		wsprintf(szBuf, "%ld ", reg);
		SetDlgItemText(hwnd, IDC_STA_XCTR, szBuf);
				
		/* JEglǍ */
		sct520_ReadCtr(hDev, Y_CH, &reg);
		/* \ */
		wsprintf(szBuf, "%ld ", reg);
		SetDlgItemText(hwnd, IDC_STA_YCTR, szBuf);
	}

	/* Xe[^X\ */
	if(sts & 0x10) {	/* wbsqJEg~ */
		SendDlgItemMessage(hwnd, IDC_STA_XRUN, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht);
	} else {			/* wbsqJEg */
		SendDlgItemMessage(hwnd, IDC_STA_XRUN, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn);
	}

	if(sts & 0x20) {	/* xbsqJEg~ */
		SendDlgItemMessage(hwnd, IDC_STA_YRUN, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht);
	} else {			/* xbsqJEg */
		SendDlgItemMessage(hwnd, IDC_STA_YRUN, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn);
	}
}

/* Rp[^ݒ */
void SetCmpData(HWND hwnd)
{
	char	szBuf[255];
	WORD	cmpp;	/* Rp[^ݒ|[gf[^ */
	WORD	cinp;	/* vo͐ݒ|[gf[^ */
	DWORD	rnv1;	/* ݒPf[^ */
	DWORD	rnv2;	/* ݒQf[^ */
	DWORD	reg;
	DWORD	dwdt;

	/* RCMP1ݒ */
	GetDlgItemText(hwnd, IDC_EDT_RCM1, szBuf, 16);
	reg = atol(szBuf);
	ct520_wXYReg(hDev, 0x82,  reg);
	
	/* RCMP2ݒ */
	GetDlgItemText(hwnd, IDC_EDT_RCM2, szBuf, 16);
	reg = atol(szBuf);
	ct520_wXYReg(hDev, 0x83,  reg);

	/* RCMP3ݒ */
	GetDlgItemText(hwnd, IDC_EDT_RCM3, szBuf, 16);
	reg = atol(szBuf);
	ct520_wXYReg(hDev, 0x84,  reg);

	/* RCMP4ݒ */
	GetDlgItemText(hwnd, IDC_EDT_RCM4, szBuf, 16);
	reg = atol(szBuf);
	ct520_wXYReg(hDev, 0x85,  reg);

	/* WX^EIvV|[gǍ */
	ct520_rXYReg(hDev, 0xc7, &rnv1);		/* ݒP */
	ct520_rXYReg(hDev, 0xc8, &rnv2);		/* ݒQ */
	ct520_rPortW(hDev, CMP_PORT, &cmpp);	/* Rp[^ݒ|[g */
	ct520_rPortW(hDev, CIN_PORT, &cinp);	/* vo͐ݒ|[g */

	dwdt = 0;

    /* RCMP1rJE^ݒ */
    if(IsDlgButtonChecked(hwnd, IDC_RAD_CP1X) == BST_CHECKED)	dwdt  = 0x00000000;	/* XCTR */
    else														dwdt  = 0x01000000; /* YCTR */
    
    /* RCMP2rJE^ݒ */
    if(IsDlgButtonChecked(hwnd, IDC_RAD_CP2X) == BST_CHECKED)	dwdt |= 0x00000000;	/* XCTR */
    else														dwdt |= 0x02000000; /* YCTR */

    /* RCMP3rJE^ݒ */
    if(IsDlgButtonChecked(hwnd, IDC_RAD_CP3X) == BST_CHECKED)	dwdt |= 0x00000000;	/* XCTR */
    else														dwdt |= 0x04000000; /* YCTR */

    /* RCMP4rJE^ݒ */
    if(IsDlgButtonChecked(hwnd, IDC_RAD_CP4X) == BST_CHECKED)	dwdt |= 0x00000000;	/* XCTR */
    else														dwdt |= 0x08000000; /* YCTR */
    
    /* WX^Pݒ(RCMP1 ` RCMP4rJE^ݒ) */
	rnv1 &= ~0x0f000000;
    rnv1 |=  dwdt;

	if(IsDlgButtonChecked(hwnd, IDC_RAD_CMP1) == BST_CHECKED) {
		/* CMP1OUT̔r@ݒ */
		dwdt = 0;
		if(IsDlgButtonChecked(hwnd, IDC_RAD_CP10) == BST_CHECKED)		dwdt = 0x00000000;
		else if(IsDlgButtonChecked(hwnd, IDC_RAD_CP11) == BST_CHECKED)	dwdt = 0x00000001;
		else if(IsDlgButtonChecked(hwnd, IDC_RAD_CP12) == BST_CHECKED)	dwdt = 0x00000002;
		else if(IsDlgButtonChecked(hwnd, IDC_RAD_CP13) == BST_CHECKED)	dwdt = 0x00000003;
		else if(IsDlgButtonChecked(hwnd, IDC_RAD_CP14) == BST_CHECKED)	dwdt = 0x00000004;
		else if(IsDlgButtonChecked(hwnd, IDC_RAD_CP15) == BST_CHECKED)	dwdt = 0x00000005;
		else if(IsDlgButtonChecked(hwnd, IDC_RAD_CP16) == BST_CHECKED)	dwdt = 0x00000006;
		else if(IsDlgButtonChecked(hwnd, IDC_RAD_CP17) == BST_CHECKED)	dwdt = 0x00000007;
		else if(IsDlgButtonChecked(hwnd, IDC_RAD_CP18) == BST_CHECKED)	dwdt = 0x00000008;
		else if(IsDlgButtonChecked(hwnd, IDC_RAD_CP19) == BST_CHECKED)	dwdt = 0x00000009;
		else if(IsDlgButtonChecked(hwnd, IDC_RAD_CP1A) == BST_CHECKED)	dwdt = 0x0000000a;
		else if(IsDlgButtonChecked(hwnd, IDC_RAD_CP1B) == BST_CHECKED)	dwdt = 0x0000000b;
		else if(IsDlgButtonChecked(hwnd, IDC_RAD_CP1C) == BST_CHECKED)	dwdt = 0x0000000c;
		else if(IsDlgButtonChecked(hwnd, IDC_RAD_CP1D) == BST_CHECKED)	dwdt = 0x0000000d;
		else if(IsDlgButtonChecked(hwnd, IDC_RAD_CP1E) == BST_CHECKED)	dwdt = 0x0000000e;
		else if(IsDlgButtonChecked(hwnd, IDC_RAD_CP1F) == BST_CHECKED)	dwdt = 0x0000000f;
		
		/* ݒQݒ */
		rnv2 &= ~0x0000000f;
		rnv2 |=  dwdt;			/* CMP1ݒ */
		
		rnv2 &= ~0x10000000;	/* CMPOUT1M */
		rnv2 |=  0x00000f00;	/* CMP3, CMP4ɏs(}XN) */

		/* Rp[^ݒ|[gݒ */
		cmpp &= ~0x00ff;	
		cmpp |=  0x0001;		/* CMPOUT1M */

		/* vo͐ݒ|[gݒ */
		cinp &= ~0x0001;		/* XYOUT1̏o͂CMPOUT1M */
	}

	if(IsDlgButtonChecked(hwnd, IDC_RAD_CMP3) == BST_CHECKED) {
		/* CMP3OUT̔r@ݒ */
		dwdt = 0;
		if(IsDlgButtonChecked(hwnd, IDC_RAD_CP30) == BST_CHECKED)		dwdt = 0x00000000;
		else if(IsDlgButtonChecked(hwnd, IDC_RAD_CP31) == BST_CHECKED)	dwdt = 0x00000100;
		else if(IsDlgButtonChecked(hwnd, IDC_RAD_CP32) == BST_CHECKED)	dwdt = 0x00000200;
		else if(IsDlgButtonChecked(hwnd, IDC_RAD_CP33) == BST_CHECKED)	dwdt = 0x00000300;
		else if(IsDlgButtonChecked(hwnd, IDC_RAD_CP34) == BST_CHECKED)	dwdt = 0x00000400;
		else if(IsDlgButtonChecked(hwnd, IDC_RAD_CP35) == BST_CHECKED)	dwdt = 0x00000500;
		else if(IsDlgButtonChecked(hwnd, IDC_RAD_CP36) == BST_CHECKED)	dwdt = 0x00000600;
		else if(IsDlgButtonChecked(hwnd, IDC_RAD_CP37) == BST_CHECKED)	dwdt = 0x00000700;
		else if(IsDlgButtonChecked(hwnd, IDC_RAD_CP38) == BST_CHECKED)	dwdt = 0x00000800;
		else if(IsDlgButtonChecked(hwnd, IDC_RAD_CP39) == BST_CHECKED)	dwdt = 0x00000900;
		else if(IsDlgButtonChecked(hwnd, IDC_RAD_CP3A) == BST_CHECKED)	dwdt = 0x00000a00;
		else if(IsDlgButtonChecked(hwnd, IDC_RAD_CP3B) == BST_CHECKED)	dwdt = 0x00000b00;
		else if(IsDlgButtonChecked(hwnd, IDC_RAD_CP3C) == BST_CHECKED)	dwdt = 0x00000c00;
		else if(IsDlgButtonChecked(hwnd, IDC_RAD_CP3D) == BST_CHECKED)	dwdt = 0x00000d00;
		else if(IsDlgButtonChecked(hwnd, IDC_RAD_CP3E) == BST_CHECKED) 	dwdt = 0x00000e00;
		else if(IsDlgButtonChecked(hwnd, IDC_RAD_CP3F) == BST_CHECKED)	dwdt = 0x00000f00;
		
		/* ݒQݒ */
		rnv2 &=  ~0x00000f00;
		rnv2 |=  dwdt;			/* CMP3ݒ */
		rnv2 |=  0x10000000;	/* CMPOUT1,CMPOUT2M}XN */
		
		/* Rp[^ݒ|[gݒ */
		cmpp &= ~0x00ff;	
		cmpp |=  0x0004;		/* CMPOUT3M */

		/* vo͐ݒ|[gݒ */
		cinp |=  0x0001;		/* XYOUT1̏o͂CMPOUT3M */
	}

    /* XYOUT1o͕ݒ */
    if(IsDlgButtonChecked(hwnd, IDC_RAD_WDT1) == BST_CHECKED) {
        /* Level */
		rnv2 &= ~0x000f0000;		/* ݒQݒ(CMPOUT1 Level) */
		cinp &= ~0x0010;			/* vo͐ݒ|[gݒ(XYOUT1 NOT STRCH) */        
	} else if(IsDlgButtonChecked(hwnd, IDC_RAD_WDT2) == BST_CHECKED) {
		rnv2 &= ~0x000f0000;		
        rnv2 |=  0x00050000;		/* ݒQݒ(CMPOUT1 50usec) */
		cinp |=  0x0010;			/* vo͐ݒ|[gݒ(XYOUT1 104msec) */        
	}

	/* WX^EIvV|[g */
	ct520_wXYReg(hDev, 0x87, rnv1);			/* ݒP */
	ct520_wXYReg(hDev, 0x88, rnv2);			/* ݒQ */
	ct520_wPortW(hDev, CMP_PORT, cmpp);		/* Rp[^ݒ|[g */
	ct520_wPortW(hDev, CIN_PORT, cinp);		/* vo͐ݒ|[g */
}

/* Rp[^\ */
void SetCmpText(HWND hwnd)
{
    char szBuf0[255];
	char szBuf1[255];
    char szBuf2[255];
    char szBuf3[255];
    char szBuf4[255];
    
	if(IsDlgButtonChecked(hwnd, IDC_RAD_CP1X) == BST_CHECKED)	wsprintf(szBuf1, "XCTR");
	else														wsprintf(szBuf1, "YCTR");
	if(IsDlgButtonChecked(hwnd, IDC_RAD_CP2X) == BST_CHECKED)	wsprintf(szBuf2, "XCTR");
	else														wsprintf(szBuf2, "YCTR");
	if(IsDlgButtonChecked(hwnd, IDC_RAD_CP3X) == BST_CHECKED)	wsprintf(szBuf3, "XCTR");
	else														wsprintf(szBuf3, "YCTR");
	if(IsDlgButtonChecked(hwnd, IDC_RAD_CP4X) == BST_CHECKED)	wsprintf(szBuf4, "XCTR");
	else														wsprintf(szBuf4, "YCTR");
    
	wsprintf(szBuf0, "%s%s","RCMP1 < ", szBuf1);
	SetDlgItemText(hwnd, IDC_RAD_CP10, szBuf0);
	wsprintf(szBuf0, "%s%s","RCMP1 > ", szBuf1);
	SetDlgItemText(hwnd, IDC_RAD_CP11, szBuf0);
	wsprintf(szBuf0, "%s%s%s","RCMP1 = ", szBuf1, "(JEg֌W)");
	SetDlgItemText(hwnd, IDC_RAD_CP12, szBuf0);
	wsprintf(szBuf0, "%s%s%s","RCMP1 = ", szBuf1, "(JEgAbv)");
	SetDlgItemText(hwnd, IDC_RAD_CP13, szBuf0);
	wsprintf(szBuf0, "%s%s%s","RCMP1 = ", szBuf1, "(JEg_E)");
	SetDlgItemText(hwnd, IDC_RAD_CP14, szBuf0);
	wsprintf(szBuf0, "%s%s","RCMP2 < ", szBuf2);
	SetDlgItemText(hwnd, IDC_RAD_CP15, szBuf0);
	wsprintf(szBuf0, "%s%s","RCMP2 > ", szBuf2);
	SetDlgItemText(hwnd, IDC_RAD_CP16, szBuf0);
	wsprintf(szBuf0, "%s%s%s","RCMP2 = ", szBuf2, "(JEg֌W)");
	SetDlgItemText(hwnd, IDC_RAD_CP17, szBuf0);
	wsprintf(szBuf0, "%s%s%s","RCMP2 = ", szBuf2, "(JEgAbv)");
	SetDlgItemText(hwnd, IDC_RAD_CP18, szBuf0);
	wsprintf(szBuf0, "%s%s%s","RCMP2 = ", szBuf2, "(JEg_E)");
	SetDlgItemText(hwnd, IDC_RAD_CP19, szBuf0);
	wsprintf(szBuf0, "%s%s%s%s%s","RCMP1 < ", szBuf1, " AND ", szBuf2, " < RCMP2");
	SetDlgItemText(hwnd, IDC_RAD_CP1A, szBuf0);
	wsprintf(szBuf0, "%s%s%s%s%s","RCMP1 > ", szBuf1, " OR  ", szBuf2, " > RCMP2");
	SetDlgItemText(hwnd, IDC_RAD_CP1B, szBuf0);
	wsprintf(szBuf0, "%s%s%s%s%s%s%s%s%s","(RCMP1 < ", szBuf1, " AND ", szBuf2, " < RCMP2) AND (RCMP3 < ", szBuf3, " AND ", szBuf4, " < RCMP4)");
	SetDlgItemText(hwnd, IDC_RAD_CP1C, szBuf0);
	wsprintf(szBuf0, "%s%s%s%s%s%s%s%s%s","(RCMP1 < ", szBuf1, " AND ", szBuf2, " < RCMP2) OR  (RCMP3 < ", szBuf3, " AND ", szBuf4, " < RCMP4)");
	SetDlgItemText(hwnd, IDC_RAD_CP1D, szBuf0);
	wsprintf(szBuf0, "%s%s%s%s%s%s%s%s%s","(RCMP1 > ", szBuf1, " OR  ", szBuf2, " > RCMP2) AND (RCMP3 > ", szBuf3, " OR  ", szBuf4, " > RCMP4)");
	SetDlgItemText(hwnd, IDC_RAD_CP1E, szBuf0);
	wsprintf(szBuf0, "%s%s%s%s%s%s%s%s%s","(RCMP1 > ", szBuf1, " OR  ", szBuf2, " > RCMP2) OR (RCMP3 > ", szBuf3, " OR  ", szBuf4, " > RCMP4)");
	SetDlgItemText(hwnd, IDC_RAD_CP1F, szBuf0);

	wsprintf(szBuf0, "%s%s","RCMP3 < ", szBuf3);
	SetDlgItemText(hwnd, IDC_RAD_CP30, szBuf0);
	wsprintf(szBuf0, "%s%s","RCMP3 > ", szBuf3);
	SetDlgItemText(hwnd, IDC_RAD_CP31, szBuf0);
	wsprintf(szBuf0, "%s%s%s","RCMP3 = ", szBuf3, "(JEg֌W)");
	SetDlgItemText(hwnd, IDC_RAD_CP32, szBuf0);
	wsprintf(szBuf0, "%s%s%s","RCMP3 = ", szBuf3, "(JEgAbv)");
	SetDlgItemText(hwnd, IDC_RAD_CP33, szBuf0);
	wsprintf(szBuf0, "%s%s%s","RCMP3 = ", szBuf3, "(JEg_E)");
	SetDlgItemText(hwnd, IDC_RAD_CP34, szBuf0);
	wsprintf(szBuf0, "%s%s","RCMP4 < ", szBuf4);
	SetDlgItemText(hwnd, IDC_RAD_CP35, szBuf0);
	wsprintf(szBuf0, "%s%s","RCMP4 > ", szBuf4);
	SetDlgItemText(hwnd, IDC_RAD_CP36, szBuf0);
	wsprintf(szBuf0, "%s%s%s","RCMP4 = ", szBuf4, "(JEg֌W)");
	SetDlgItemText(hwnd, IDC_RAD_CP37, szBuf0);
	wsprintf(szBuf0, "%s%s%s","RCMP4 = ", szBuf4, "(JEgAbv)");
	SetDlgItemText(hwnd, IDC_RAD_CP38, szBuf0);
	wsprintf(szBuf0, "%s%s%s","RCMP4 = ", szBuf4, "(JEg_E)");
	SetDlgItemText(hwnd, IDC_RAD_CP39, szBuf0);
	wsprintf(szBuf0, "%s%s%s%s%s","RCMP3 < ", szBuf3, " AND ", szBuf4, " < RCMP4");
	SetDlgItemText(hwnd, IDC_RAD_CP3A, szBuf0);
	wsprintf(szBuf0, "%s%s%s%s%s","RCMP3 > ", szBuf3, " OR  ", szBuf4, " > RCMP4");
	SetDlgItemText(hwnd, IDC_RAD_CP3B, szBuf0);
	wsprintf(szBuf0, "%s","YCTR < XCTR");
	SetDlgItemText(hwnd, IDC_RAD_CP3C, szBuf0);
	wsprintf(szBuf0, "%s","YCTR > XCTR");
	SetDlgItemText(hwnd, IDC_RAD_CP3D, szBuf0);
	wsprintf(szBuf0, "%s","YCTR = XCTR");
	SetDlgItemText(hwnd, IDC_RAD_CP3E, szBuf0);
	wsprintf(szBuf0, "%s","ɔrs");
	SetDlgItemText(hwnd, IDC_RAD_CP3F, szBuf0);
}
