/************************************/
/*  HPCI-CTR520F series sample(Vc)	*/
/*	    file name:h_wdt.c			*/
/*      date     :2003/02/20		*/
/*      version  :1.0.0.0 			*/
/************************************/

#include	<windows.h>
#include	"resource.h"
#include	"hictr520.h"
#include	"spct5200.h"

void	DlgWdtLoad  (HWND);		/* _CAO[h */
void	DlgWdtUnload(HWND);		/* _CAOA[h */
void	OpenWdtDev  (HWND);		/* foCXI[v */
void	CloseWdtDev (HWND);		/* foCXN[Y */
void	TmrReadWdt  (HWND);		/* JE^Ǎ^C} */
void	SetWdtData	(HWND);		/* v̐ݒ */

/*	foCX֌W̃_CAO{bNX  */
BOOL CALLBACK DlgWdtProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	LPARAM	dummy;
	long	reg;
	char	szBuf[255];
	double	dt;

	dummy = lParam;

	switch(message) {
		/*  */
		case WM_SHOWWINDOW:	DlgWdtLoad(hwnd);				break;

		/* {^NbN̏ */
		case WM_COMMAND:
			switch (LOWORD(wParam)) {
				/* foCXI[v */
				case IDC_BTN_OPEN:	OpenWdtDev(hwnd);		break;

				/* foCXN[Y */
				case IDC_BTN_CLOS:	CloseWdtDev(hwnd);		break;
			
				case IDC_BTN_YREAD:	
					/* őlf[^Ǎ */
					sct520_ReadMax(hDev, Y_CH, &reg);
					/* \ */
					dt = (double)reg * 25 / 1000;
					wsprintf(szBuf, "%ld ", (long)dt);
					SetDlgItemText(hwnd, IDC_STA_YMAX, szBuf);
							
					/* ŏlf[^Ǎ */
					sct520_ReadMin(hDev, Y_CH, &reg);
					/* \ */
					dt = (double)reg * 25 / 1000;
					wsprintf(szBuf, "%ld ", (long)dt);
					SetDlgItemText(hwnd, IDC_STA_YMIN, szBuf);

					/* b`f[^Ǎ */
					sct520_ReadLtc(hDev, Y_CH, &reg);
					/* \ */
					dt = (double)reg * 25 / 1000;
					wsprintf(szBuf, "%ld ", (long)dt);
					SetDlgItemText(hwnd, IDC_STA_YLTC, szBuf);
															break;
				case IDC_BTN_M2STA:
					SetWdtData(hwnd);
					sct520_StrtCtr(hDev, Y_CH);	/* JEgX^[g */
					sct520_StrtMM(hDev, Y_CH);	/* vJn */
					
					/* ʕ\(쒆̓JEg͌`ύXs) */
					EnableWindow(GetDlgItem(hwnd, IDC_STA_SLOP),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_STA_SLRD),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_STA_STRT),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_STA_STOP),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_MANU),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_AUTO),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_STAR),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_STAF),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_STBR),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_STBF),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_SPAR),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_SPAF),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_SPBR),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_SPBF),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_BTN_M2STA), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_BTN_M2STP), TRUE);
																break;
				case IDC_BTN_M2STP:
					sct520_StopMM(hDev, Y_CH);		/* vI */
					sct520_StopCtr(hDev, Y_CH);		/* JEgXgbv */

					/* ~̎̓JEg͌`I */
					EnableWindow(GetDlgItem(hwnd, IDC_STA_SLOP),  TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_STA_SLRD),  TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_STA_STRT),  TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_STA_STOP),  TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_MANU),  TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_AUTO),  TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_STAR),  TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_STAF),  TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_STBR),  TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_STBF),  TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_SPAR),  TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_SPAF),  TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_SPBR),  TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_SPBF),  TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_BTN_M2STA), TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_BTN_M2STP), FALSE);
																break;

				case IDC_BTN_M2INI:	sct520_InitMM(hDev, Y_CH);	break;

				case IDC_RAD_MANU:
					if(IsDlgButtonChecked(hwnd, IDC_RAD_MANU) == BST_CHECKED) {
						EnableWindow(GetDlgItem(hwnd, IDC_BTN_YREAD), TRUE);
					}
																break;
				case IDC_RAD_AUTO:
					if(IsDlgButtonChecked(hwnd, IDC_RAD_AUTO) == BST_CHECKED) {
						EnableWindow(GetDlgItem(hwnd, IDC_BTN_YREAD), FALSE);
					}
																break;
			}
																break;
		/* ^C} */
		case WM_TIMER:
			switch(LOWORD(wParam)) {
				case IDM_TMR_READ:	TmrReadWdt(hwnd);			break;
			}
																break;
		/* I */
		case WM_CLOSE:	DlgWdtUnload(hwnd);						break;
		
		/* I */
		case WM_DESTROY:hDlg = NULL;							break;
	}
	return 0;
}

/* foCXI[v */
void OpenWdtDev(HWND hwnd)
{
    char	szBuf[255];
	DWORD	ret;
	DWORD	reg;

	if(hDev == -1) {
        //{[hI[v
        ret = sct520_OpenID(&hDev, gBrdID);
		if(ret & 0x1000) {
			wsprintf(szBuf, "%s\n%s", "{[h擾s!", 
							"{[h}ĂȂAhCoCXg[ĂȂ̃G[");	
			MessageBox(hwnd, szBuf, "ErrorMessage", MB_OK);
			return;
		} else if(ret & 0x2000) {
			wsprintf(szBuf, "%s\n%s", "{[h擾s!", "VXes̃G[");	
			MessageBox(hwnd, szBuf, "ErrorMessage", MB_OK);
            return;
        } else if(ret & 0x4000) {
			wsprintf(szBuf, "%s%ld%s", "w肵{[hhc ", gBrdID, "̃{[h}Ă܂");
			MessageBox(hwnd, szBuf, "ErrorMessage", MB_OK);
            return;
		} else if(ret & 0x8000) {
			wsprintf(szBuf, "%s\n%s", "foCXI[vs!", "VXes̃G[");	
			MessageBox(hwnd, szBuf, "ErrorMessage", MB_OK);
			return;
		}
        
        // {[h̏
		ret = sct520_InitCtr(hDev);
		if(ret) {
			wsprintf(szBuf, "JE^[s!");	
			MessageBox(hwnd, szBuf, "ErrorMessage", MB_OK);
			DlgWdtUnload(hwnd);
			return;
		}

		ct520_rXYReg(hDev, 0xc7, &reg);			/* WX^PFԑ@(̫) */
		reg &= ~0x00000fc0;						/*  b11-8=0:Jn:x``I:x` */
		reg |=  0x00000080;						/*  b7=1:͐MGbWԂ̎ԑ */
		ct520_wXYReg(hDev, 0x87,  reg);			/*  b6=0:YCTR:YA,YB */

		/* {^\ */
		EnableWindow(GetDlgItem(hwnd, IDC_STA_YCH),   TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_0001),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_0002),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_0003),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_0004),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_0005),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_0006),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_0007),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_BTN_YREAD), TRUE);

		EnableWindow(GetDlgItem(hwnd, IDC_BTN_M2STA), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_BTN_M2INI), TRUE);

		EnableWindow(GetDlgItem(hwnd, IDC_STA_SLOP),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_SLRD),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_STRT),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_STOP),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_MANU),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_AUTO),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_STAR),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_STAF),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_STBR),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_STBF),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_SPAR),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_SPAF),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_SPBR),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_SPBF),  TRUE);

		EnableWindow(GetDlgItem(hwnd, IDC_BTN_OPEN),  FALSE);	/* foCXI[v{^gps */
		EnableWindow(GetDlgItem(hwnd, IDC_BTN_CLOS),  TRUE);	/* foCXN[Y{^gp */

		/* WI{^`FbN */
		CheckDlgButton(hwnd, IDC_RAD_MLT4, BST_CHECKED);
		CheckDlgButton(hwnd, IDC_RAD_AUTO, BST_CHECKED);

		CheckDlgButton(hwnd, IDC_RAD_STAR, BST_CHECKED);
		CheckDlgButton(hwnd, IDC_RAD_SPAF, BST_CHECKED);
		
		SetTimer(hwnd, IDM_TMR_READ, 100, NULL);		/* ^C}Jn(100msec) */
	}
}

/* foCXN[Y */
void CloseWdtDev(HWND hwnd)
{
	DWORD	ret;

	if(hDev == -1)	return;
	
	KillTimer(hwnd, IDM_TMR_READ);						/* ^C}I */
	
	sct520_StopMM(hDev, Y_CH);

	/* ʕ\ */
	CheckDlgButton(hwnd, IDC_RAD_MANU, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_AUTO, BST_UNCHECKED);

	CheckDlgButton(hwnd, IDC_RAD_STAR, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_STAF, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_STBR, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_STBF, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_SPAR, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_SPAF, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_SPBR, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_SPBF, BST_UNCHECKED);

	SendDlgItemMessage(hwnd, IDC_STA_YRUN, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL);

	SetDlgItemText(hwnd, IDC_STA_YMAX, "");
	SetDlgItemText(hwnd, IDC_STA_YMIN, "");

	EnableWindow(GetDlgItem(hwnd, IDC_STA_YCH),   FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_0001),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_0002),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_0003),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_0004),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_0005),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_0006),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_0007),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_BTN_YREAD), FALSE);

	EnableWindow(GetDlgItem(hwnd, IDC_BTN_M2STA), FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_BTN_M2STP), FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_BTN_M2INI), FALSE);

	EnableWindow(GetDlgItem(hwnd, IDC_STA_SLOP),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_SLRD),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_STRT),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_STOP),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_MANU),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_AUTO),  FALSE);

	EnableWindow(GetDlgItem(hwnd, IDC_RAD_STAR),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_STAF),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_STBR),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_STBF),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_SPAR),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_SPAF),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_SPBR),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_SPBF),  FALSE);

	EnableWindow(GetDlgItem(hwnd, IDC_BTN_OPEN),  TRUE);	/* foCXI[v{^gp */
	EnableWindow(GetDlgItem(hwnd, IDC_BTN_CLOS),  FALSE);	/* foCXN[Y{^gps */
	
	ret = ct520_CloseDevice(hDev);
	
	/* foCXN[YςȂhDev=-1(foCXI[v^N[YԔf̈) */
	hDev = (DWORD)-1;
}

/* ʏ */
void DlgWdtLoad(HWND hwnd)
{
	HDC		hDC;
	
	/* w肳ꂽEBhẼNCAg̈ɑ΂foCXReLXg̃nh擾 */
	hDC = GetDC(hwnd);

	/* foCXReLXg */
	ReleaseDC(hwnd, hDC);

	/* rbg}bṽ[h */
	hWht  = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_WHITE));
	hGrn  = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_GREEN));

	hDev = (DWORD)-1;
}

/*	e_CAO鏈 */
void DlgWdtUnload(HWND hwnd)
{	
	if(hDev != -1) {
		KillTimer(hwnd, IDM_TMR_READ);	/* ^C}I */
		ct520_CloseDevice(hDev);		/* foCXN[Y */
		hDev = (DWORD)-1;				/* foCXN[YςȂhDev=-1(foCXI[v^N[YԔf̈) */
	}

	DestroyWindow(hwnd);				/* _CAO{bNX */
	hDlg = NULL;						/* _CAO{bNX̃nh */
	ShowWindow(hInx, SW_SHOWDEFAULT);	/* C̃EBhE\ */
}

/* JEglCőlf[^Cŏlf[^CXe[^XǍ */
void TmrReadWdt(HWND hwnd)
{
	char	szBuf[255];
	WORD	sts;
	long	reg;
	double	dt;

	/* Xe[^XǍ */
	ct520_rXYSts(hDev, &sts);
	/* Xe[^X\ */
	if((!(sts & 0x80)) && (sts & 0x20)) {
		SendDlgItemMessage(hwnd, IDC_STA_YRUN, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht);
	} else {
		SendDlgItemMessage(hwnd, IDC_STA_YRUN, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn);
	}

	if(IsDlgButtonChecked(hwnd, IDC_RAD_AUTO) == BST_CHECKED) {					
		/* őlf[^Ǎ */
		sct520_ReadMax(hDev, Y_CH, &reg);
		/* \ */
		dt = (double)reg * 25 / 1000;
		wsprintf(szBuf, "%ld ", (long)dt);
		SetDlgItemText(hwnd, IDC_STA_YMAX, szBuf);
				
		/* ŏlf[^Ǎ */
		sct520_ReadMin(hDev, Y_CH, &reg);
		/* \ */
		dt = (double)reg * 25 / 1000;
		wsprintf(szBuf, "%ld ", (long)dt);
		SetDlgItemText(hwnd, IDC_STA_YMIN, szBuf);

		/* b`f[^Ǎ */
		sct520_ReadLtc(hDev, Y_CH, &reg);
		/* \ */
		dt = (double)reg * 25 / 1000;
		wsprintf(szBuf, "%ld ", (long)dt);
		SetDlgItemText(hwnd, IDC_STA_YLTC, szBuf);
	}
}

/* v̐ݒ */
void SetWdtData(HWND hwnd)
{
	DWORD	dwdt;	
	DWORD	rnv1;	/* ݒP */
	
	/* Jn */
	if(IsDlgButtonChecked(hwnd, IDC_RAD_STAR) == BST_CHECKED)		dwdt = 0x00000000;
	else if(IsDlgButtonChecked(hwnd, IDC_RAD_STAF) == BST_CHECKED)	dwdt = 0x00000100;
	else if(IsDlgButtonChecked(hwnd, IDC_RAD_STBR) == BST_CHECKED)	dwdt = 0x00000200; 
	else if(IsDlgButtonChecked(hwnd, IDC_RAD_STBF) == BST_CHECKED) 	dwdt = 0x00000300;

	/* I */
	if(IsDlgButtonChecked(hwnd, IDC_RAD_SPAR) == BST_CHECKED)		dwdt |= 0x00000000;
	else if(IsDlgButtonChecked(hwnd, IDC_RAD_SPAF) == BST_CHECKED)	dwdt |= 0x00000400;
	else if(IsDlgButtonChecked(hwnd, IDC_RAD_SPBR) == BST_CHECKED)	dwdt |= 0x00000800;
	else if(IsDlgButtonChecked(hwnd, IDC_RAD_SPBF) == BST_CHECKED)	dwdt |= 0x00000c00;

	ct520_rXYReg(hDev, 0xc7, &rnv1);	
	rnv1 &= ~0x00000f00;
	rnv1 |=  dwdt;
	ct520_wXYReg(hDev, 0x87,  rnv1);
}
