/********************************/
/*  CTR520 Series				*/
/*  UGOKASHITEMIRU(VisualC 5.0)	*/
/*	    file name:tpct5200.h	*/
/*      date     :2003/02/20	*/
/*      version  :1.0.0.0 		*/
/********************************/

#define INVALID_HANDLE	0xffffffff	/* foCXnh */
#define DEF_RCM1		1000		/* RCMP1f[^(ftHg"1000") */
#define DEF_ETMR 		1000		/* ETMR   (ftHg"1000") */

#define	ILL_XYCP		0x0100		/* wxRp[^f[^s */
#define	ILL_ZUCP		0x0200		/* ytRp[^f[^s */
#define	ILL_ETMR		0x0400		/* Cxg^C}͈͊O */
#define	ILL_NULL		0x0800		/* Cxg^C}GfBbg{bNXɐlȂ */

#define ZTM_PORT		0x20		/* ýACxg^C}j^ */			
#define INP_PORT		0x28		/* ėp̓|[g */
#define OUT_PORT		0x2c		/* ėpo̓|[g */
#define CMP_PORT		0x30		/* CMPo͐ݒ|[g  */
#define TMR_PORT		0x32		/* ^C}o͐ݒ|[g  */
#define CIN_PORT		0x34		/* vo͐ݒ|[g */
									/* XY/ZUOUT1`4ٽ104msec */
									/* XY/ZUOUT1,2o͑I */
#define CLR_PORT		0x36		/* JE^NAݒ|[g */
#define LTC_PORT		0x38		/* b`ݒ|[g */
#define INT_PORT		0x50		/* }XNݒ|[g */
#define PCI_PORT		0x52		/* PCIoXւ̊}XNݒ|[g */

#define XYCH			0			/* #1CCL(XYch) */
#define ZUCH			1			/* #2CCL(ZUch) */
#define ETMR			2			/* Cxg^C} */
										
#define	CNTMAX			16			/* {[hő吔16 */
#define M_CH			4			/* ch ő吔(ftHg4) */
#define X_CH			0			/* Xch */
#define Y_CH			1			/* Ych */
#define Z_CH			2			/* Zch */
#define U_CH			3			/* Uch */

#define OUT1_NO			0			/* ėpo1 */
#define OUT2_NO			1			/* ėpo2 */
#define OUT3_NO			2			/* ėpo3 */
#define OUT4_NO			3			/* ėpo4 */

#define MLT1_NO			0			/* JEg͌`(ʑ {w1) */
#define MLT2_NO			1			/* JEg͌`(ʑ {w2) */
#define MLT4_NO			2			/* JEg͌`(ʑ {w4) */
#define UPDN_NO			3			/* JEg͌`(UP/DOWNpX) */
#define DIRC_NO			5			/* JEg͌`(ƃpX) */

// R{{bNX
#define DEVNO			0			// foCXԍ
#define BRDID			1			// {[hID

/* \[Xt@CȊÕRg[ID */
#define	IDM_TMR_READ	11001		/* ^C} */

/* nḧ */
HINSTANCE		hInst;					/* CX^Xnh */
HBITMAP			hGrn, hWht;				/* rbg}bv */
DWORD			hDev = INVALID_HANDLE;	/* foCXnh */
HPCDEVICEINFO	HpcDevInfo[CNTMAX];		/* foCX */
HPCDEVICEINFO	HpcDevInfo2;			/* foCX */
DWORD			gCh = M_CH;				/* Ch */
DWORD			gCnt = 0;				/* foCX */

HWND	hCmb[BRDID + 1];				/* R{{bNX */
WORD	wBrdId	= 0;					/* {[hID */
WORD	wOpen	= DEVNO;				/* foCX(ftHgFfoCXԍ) */
WORD	wOpen2  = DEVNO;
DWORD	dwCmbIx	= 0;					/* foCX(ftHgF1) */
DWORD	dwCmbIx2 = 0;
long	gCmp[2] = {DEF_RCM1, DEF_RCM1};	/* Rp[^Prf[^ */			
DWORD	gTmr = DEF_ETMR;				/* ^C} */
WORD	gCtr[2] = {0};					/* JE^tO */			
WORD	gWdt[3] = {0};					/* o̓pXtO */

/*	֐ ݒ */
LRESULT	CALLBACK WndProc (HWND, UINT, WPARAM, LPARAM);

/* JnEI */
WORD	FormLoad(HWND);				/* vOJn */
void	FormUnload(HWND);			/* vOI */

/* ^C} */
void	TmrRead(HWND);				/* ^C}Ǎ */

/* ڍ׏ */
WORD	DevOpen(HWND);		/* foCXI[v */
WORD	DevClose(HWND);		/* foCXN[Y */
WORD	SetData(HWND);		/* X^[g{^NbŇvݒ */
							/* JEg͐M`                   */
							/* b`gK                       */
							/* Z͂ɂJE^NA            */
							/* Rp[^ɂJE^NA       */
							/* ETMRݒ @@@@@		  */

void	BtnStrt_Click(HWND, WORD);
void	BtnStop_Click(HWND, WORD);
void	BtnClr_Click (HWND, WORD);
void	BtnLtch_Click(HWND, WORD);
void	BtnRead_Click(HWND, WORD);
void	CmbInf_Click (HWND, WPARAM);

WORD	tct520_InitCtr	 (DWORD);				/* {[h̏ */
WORD	tct520_InitOpt	 (DWORD);				/* IvV|[g̏ */
DWORD	tct520_StrtCtr   (DWORD, WORD);
DWORD	tct520_StopCtr   (DWORD, WORD);
DWORD	tct520_ReadCtr   (DWORD, WORD, long*);
DWORD	tct520_ReadLtc   (DWORD, WORD, long*);
DWORD	tct520_SelCtrMode(DWORD, WORD, WORD);
DWORD	tct520_ClrCtr    (DWORD, WORD);
DWORD	tct520_SoftLtc	 (DWORD, WORD);
DWORD	tct520_SetAutoClr(DWORD, WORD, WORD);
DWORD	tct520_Outp		 (DWORD, WORD);

long	isNum(char*);




