
using System;
using System.Runtime.InteropServices;

/// <summary>
///  PCI CTR Series Devise Driver I/F DLL for Windows	
///		file name:hictr520.cs			
///      date     :2010/ 5/17			
///      version  :1.0.0.0 VK쐬	
///	Copyright(C) 2001-2010 Hivertec,Inc. All Rights Reserved.	
/// </summary>
public class Hictr520
{
	/// <summary>
	/// foCX
	/// </summary>
    public struct HPCDEVICEINFO
    {
        /// <summary>
        /// oXԍ
        /// </summary>
		public uint nBusNumber;
		
		/// <summary>
		/// foCXԍ
		/// </summary>
        public uint nDeviceNumber;
 
		/// <summary>
		/// I/O|[gAhX
		/// </summary>
        public uint dwIoPortAddress;
	
		/// <summary>
		/// IRQԍ
		/// </summary>
        public uint dwIrqNo;
        
		/// <summary>
		/// Ǘԍ(Windows 9xł͖)
		/// </summary>
		public uint dwNumber;
        
		/// <summary>
		/// {[hID
		/// </summary>
		public uint dwBoardID;
    }

	/// <summary>
	/// foCX̎擾
	/// </summary>
	/// <param name="pDevNum">foCX̌̊i[</param>
	/// <returns>0:C0ȊO:ُ</returns>
    [DllImport("hictr520.dll")]
    public static extern uint ct520_GetDeviceCount(ref uint pDevNum);
    
	/// <summary>
	/// foCX̎擾
	/// </summary>
	/// <param name="pDevNum">foCX̌̊i[</param>
	/// <param name="pHpcDevInfo">foCX̊i[</param>
	/// <returns>0:C0ȊO:ُ</returns>
    [DllImport("hictr520.dll")]
    public static extern uint ct520_GetDeviceInfo(ref uint pDevNum, ref HPCDEVICEINFO pHpcDevInfo);
    
	/// <summary>
	/// foCXI[v
	/// </summary>
	/// <param name="hDevID">foCXnhi[</param>
	/// <param name="pHpcDevInfo">foCX̊i[</param>
	/// <returns>0:C0ȊO:ُ</returns>
    [DllImport("hictr520.dll")]
    public static extern uint ct520_OpenDevice(ref uint hDevID, ref HPCDEVICEINFO pHpcDevInfo);
    
	/// <summary>
	/// foCXN[Y
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <returns>0:C0ȊO:ُ</returns>
    [DllImport("hictr520.dll")]
    public static extern uint ct520_CloseDevice(uint hDevID);
  
	/// <summary>
	/// XYchXe[^XǍ
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usData">f[^i[</param>
	/// <returns>0:C0ȊO:ُ</returns>
    [DllImport("hictr520.dll")]
    public static extern uint ct520_rXYSts(uint hDevID, ref ushort usData);

	/// <summary>
	/// ZUchXe[^XǍ
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usData">f[^i[</param>
	/// <returns>0:C0ȊO:ُ</returns>
	[DllImport("hictr520.dll")]
	public static extern uint ct520_rZUSts(uint hDevID, ref ushort usData);

	/// <summary>
	/// XYchR}h
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usCmd">R}h</param>
	/// <returns>0:C0ȊO:ُ</returns>
    [DllImport("hictr520.dll")]
    public static extern uint ct520_wXYCmd(uint hDevID, ushort usCmd);

	/// <summary>
	/// ZUchR}h
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usCmd">R}h</param>
	/// <returns>0:C0ȊO:ُ</returns>
	[DllImport("hictr520.dll")]
	public static extern uint ct520_wZUCmd(uint hDevID, ushort usCmd);
    
	/// <summary>
	/// XYchWX^Ǎ
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usCmd">WX^ǍR}h</param>
	/// <param name="unData">f[^i[</param>
	/// <returns>0:C0ȊO:ُ</returns>
    [DllImport("hictr520.dll")]
    public static extern uint ct520_rXYReg(uint hDevID, ushort usCmd, ref uint unData);

	/// <summary>
	/// ZUchWX^Ǎ
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usCmd">WX^ǍR}h</param>
	/// <param name="unData">f[^i[</param>
	/// <returns>0:C0ȊO:ُ</returns>
	[DllImport("hictr520.dll")]
	public static extern uint ct520_rZUReg(uint hDevID, ushort usCmd, ref uint unData);
    
	/// <summary>
	/// XYchWX^
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usCmd">WX^R}h</param>
	/// <param name="unData">f[^</param>
	/// <returns>0:C0ȊO:ُ</returns>
    [DllImport("hictr520.dll")]
    public static extern uint ct520_wXYReg(uint hDevID, ushort usCmd, uint unData);
  	
	/// <summary>
	/// ZUchWX^
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="usCmd">WX^R}h</param>
	/// <param name="unData">f[^</param>
	/// <returns>0:C0ȊO:ُ</returns>
	[DllImport("hictr520.dll")]
	public static extern uint ct520_wZUReg(uint hDevID, ushort usCmd, uint unData);
  
	/// <summary>
	/// IvV|[gǏo(oCg)
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="byCmd">IvV|[gǏoR}h</param>
	/// <param name="byData">f[^i[</param>
	/// <returns>0:C0ȊO:ُ</returns>
    [DllImport("hictr520.dll")]
    public static extern uint ct520_rPortB(uint hDevID, byte byCmd, ref byte byData);

	/// <summary>
	/// IvV|[gǏo([h)
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="byCmd">IvV|[gǏoR}h</param>
	/// <param name="usData">f[^i[</param>
	/// <returns>0:C0ȊO:ُ</returns>
    [DllImport("hictr520.dll")]
    public static extern uint ct520_rPortW(uint hDevID, byte byCmd, ref ushort usData);
    
	/// <summary>
	/// IvV|[g(oCg)
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="byCmd">IvV|[gR}h</param>
	/// <param name="byData">f[^</param>
	/// <returns>0:C0ȊO:ُ</returns>
    [DllImport("hictr520.dll")]
    public static extern uint ct520_wPortB(uint hDevID, byte byCmd, byte byData);
	
	/// <summary>
	/// IvV|[g([h)
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="byCmd">IvV|[gR}h</param>
	/// <param name="usData">f[^</param>
	/// <returns>0:C0ȊO:ُ</returns>
    [DllImport("hictr520.dll")]
    public static extern uint ct520_wPortW(uint hDevID, byte byCmd, ushort usData);
    
	/// <summary>
	/// XYcho̓obt@Ǐo
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="unData">f[^i[</param>
	/// <returns>0:C0ȊO:ُ</returns>
    [DllImport("hictr520.dll")]
    public static extern uint ct520_rXYBuf(uint hDevID, ref uint unData);

	/// <summary>
	/// ZUcho̓obt@Ǐo
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="unData">f[^i[</param>
	/// <returns>0:C0ȊO:ُ</returns>
	[DllImport("hictr520.dll")]
	public static extern uint ct520_rZUBuf(uint hDevID, ref uint unData);

	/// <summary>
	/// XYcho̓obt@
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="unData">f[^</param>
	/// <returns>0:C0ȊO:ُ</returns>
    [DllImport("hictr520.dll")]
    public static extern uint ct520_wXYBuf(uint hDevID, uint unData);

	/// <summary>
	/// ZUcho̓obt@
	/// </summary>
	/// <param name="hDevID">foCXnh</param>
	/// <param name="unData">f[^</param>
	/// <returns>0:C0ȊO:ُ</returns>
	[DllImport("hictr520.dll")]
	public static extern uint ct520_wZUBuf(uint hDevID, uint unData);
}
