/************************************/
/*  HPCI-CTR520F series sample(Vc)	*/
/*	    file name:h_dio.c			*/
/*      date     :2003/02/20		*/
/*      version  :1.0.0.0 			*/
/************************************/

#include	<windows.h>
#include	"resource.h"
#include	"hictr520.h"
#include	"spct5200.h"

void	DlgDioLoad  (HWND);		/* _CAO[h */
void	DlgDioUnload(HWND);		/* _CAOA[h */

void	OpenDioDev  (HWND);		/* foCXI[v */
void	CloseDioDev (HWND);		/* foCXN[Y */
void	TmrReadIo   (HWND);		/* ėpo͓Ǎ^C} */

/* _CAO{bNX  */
BOOL CALLBACK DlgDioProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	LPARAM	dummy;
	BYTE	bdt;
	BYTE	bit[4] = { 0x01,0x02,0x04,0x08 };	/* bit 0,1,2,3 */

	dummy = lParam;

	switch(message) {
		/*  */
		case WM_SHOWWINDOW:	DlgDioLoad(hwnd);			break;

		/* {^NbN̏ */
		case WM_COMMAND:
			switch (LOWORD(wParam)) {
				/* foCXI[v */
				case IDC_BTN_OPEN:	OpenDioDev(hwnd);	break;

				/* foCXN[Y */
				case IDC_BTN_CLOS:	CloseDioDev(hwnd);	break;

				/* OUT1o */
				case IDC_BTN_OUT1:
					ct520_rPortB(hDev, OUT_PORT, &bdt);
					bdt ^= bit[0];
					ct520_wPortB(hDev, OUT_PORT,  bdt);
														break;
				/* OUT2o */
				case IDC_BTN_OUT2:
					ct520_rPortB(hDev, OUT_PORT, &bdt);
					bdt ^= bit[1];
					ct520_wPortB(hDev, OUT_PORT,  bdt);
														break;
				/* OUT3o */
				case IDC_BTN_OUT3:					
					ct520_rPortB(hDev, OUT_PORT, &bdt);
					bdt ^= bit[2];
					ct520_wPortB(hDev, OUT_PORT,  bdt);
														break;
				/* OUT4o */
				case IDC_BTN_OUT4:
					ct520_rPortB(hDev, OUT_PORT, &bdt);
					bdt ^= bit[3];
					ct520_wPortB(hDev, OUT_PORT,  bdt);
														break;
			}
														break;
		/* ^C} */
		case WM_TIMER:
			switch(LOWORD(wParam)) {
				case IDM_TMR_READ:	TmrReadIo(hwnd);	break;
			}
														break;
		/* I */
		case WM_CLOSE:			DlgDioUnload(hwnd);		break;

		/* I */
		case WM_DESTROY:		hDlg = NULL;			break;
	}
	return 0;
}

/* foCXI[v */
void OpenDioDev(HWND hwnd)
{
    char	szBuf[255];
	DWORD	ret;

	if(hDev == -1) {
        //{[hI[v
        ret = sct520_OpenID(&hDev, gBrdID);
		if(ret & 0x1000) {
			wsprintf(szBuf, "%s\n%s", "{[h擾s!", 
							"{[h}ĂȂAhCoCXg[ĂȂ̃G[");	
			MessageBox(hwnd, szBuf, "ErrorMessage", MB_OK);
			return;
		} else if(ret & 0x2000) {
			wsprintf(szBuf, "%s\n%s", "{[h擾s!", "VXes̃G[");	
			MessageBox(hwnd, szBuf, "ErrorMessage", MB_OK);
            return;
        } else if(ret & 0x4000) {
			wsprintf(szBuf, "%s%ld%s", "w肵{[hhc ", gBrdID, "̃{[h}Ă܂");
			MessageBox(hwnd, szBuf, "ErrorMessage", MB_OK);
            return;
		} else if(ret & 0x8000) {
			wsprintf(szBuf, "%s\n%s", "foCXI[vs!", "VXes̃G[");	
			MessageBox(hwnd, szBuf, "ErrorMessage", MB_OK);
			return;
		}
        
        // {[h̏
		ret = sct520_InitCtr(hDev);
		if(ret) {
			wsprintf(szBuf, "JE^[s!");	
			MessageBox(hwnd, szBuf, "ErrorMessage", MB_OK);
			DlgDioUnload(hwnd);
			return;
		}

		/* {^\ */
		EnableWindow(GetDlgItem(hwnd, IDC_BTN_OPEN), FALSE);	/* foCXI[v{^gps */
		EnableWindow(GetDlgItem(hwnd, IDC_BTN_CLOS), TRUE);		/* foCXN[Y{^gp */
		EnableWindow(GetDlgItem(hwnd, IDC_BTN_OUT1), TRUE);		/* ėpo͂P{^gp */
		EnableWindow(GetDlgItem(hwnd, IDC_BTN_OUT2), TRUE);		/* ėpo͂Q{^gp */
		EnableWindow(GetDlgItem(hwnd, IDC_BTN_OUT3), TRUE);		/* ėpo͂R{^gp */
		EnableWindow(GetDlgItem(hwnd, IDC_BTN_OUT4), TRUE);		/* ėpo͂S{^gp */
		
		EnableWindow(GetDlgItem(hwnd, IDC_STA_DI),   TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_DO),   TRUE);

		EnableWindow(GetDlgItem(hwnd, IDC_STA_0001), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_0002), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_0003), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_0004), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_0005), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_0006), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_0007), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_0008), TRUE);

		SetTimer(hwnd, IDM_TMR_READ, 100, NULL);		/* ^C}Jn(100msec) */
	}
}

/* foCXN[Y */
void CloseDioDev(HWND hwnd)
{
	DWORD	ret;

	if(hDev == -1)	return;

	KillTimer(hwnd, IDM_TMR_READ);							/* ^C}I */

	sct520_InitCtr(hDev);									/* {[h */
	
	SendDlgItemMessage(hwnd, IDC_STA_IN1,  STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL);
	SendDlgItemMessage(hwnd, IDC_STA_IN2,  STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL);
	SendDlgItemMessage(hwnd, IDC_STA_IN3,  STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL);
	SendDlgItemMessage(hwnd, IDC_STA_IN4,  STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL);
	
	SendDlgItemMessage(hwnd, IDC_BTN_OUT1, BM_SETIMAGE,  (WPARAM)IMAGE_BITMAP, (LPARAM)NULL);
	SendDlgItemMessage(hwnd, IDC_BTN_OUT2, BM_SETIMAGE,  (WPARAM)IMAGE_BITMAP, (LPARAM)NULL);
	SendDlgItemMessage(hwnd, IDC_BTN_OUT3, BM_SETIMAGE,  (WPARAM)IMAGE_BITMAP, (LPARAM)NULL);
	SendDlgItemMessage(hwnd, IDC_BTN_OUT4, BM_SETIMAGE,  (WPARAM)IMAGE_BITMAP, (LPARAM)NULL);

	EnableWindow(GetDlgItem(hwnd, IDC_BTN_OPEN), TRUE);		/* foCXI[v{^gp */
	EnableWindow(GetDlgItem(hwnd, IDC_BTN_CLOS), FALSE);	/* foCXN[Y{^gps */
	EnableWindow(GetDlgItem(hwnd, IDC_BTN_OUT1), FALSE);	/* ėpo͂P{^gps */
	EnableWindow(GetDlgItem(hwnd, IDC_BTN_OUT2), FALSE);	/* ėpo͂Q{^gps */
	EnableWindow(GetDlgItem(hwnd, IDC_BTN_OUT3), FALSE);	/* ėpo͂R{^gps */
	EnableWindow(GetDlgItem(hwnd, IDC_BTN_OUT4), FALSE);	/* ėpo͂S{^gps */
	EnableWindow(GetDlgItem(hwnd, IDC_STA_DI),   FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_DO),   FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_0001), FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_0002), FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_0003), FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_0004), FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_0005), FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_0006), FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_0007), FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_0008), FALSE);

	ret = ct520_CloseDevice(hDev);

	/* foCXN[YςȂhDev=-1(foCXI[v^N[YԔf̈) */
	hDev = (DWORD)-1;
}

/* ʏ */
void DlgDioLoad(HWND hwnd)
{
	HDC		hDC;
	
	/* w肳ꂽEBhẼNCAg̈ɑ΂foCXReLXg̃nh擾 */
	hDC = GetDC(hwnd);

	/* foCXReLXg */
	ReleaseDC(hwnd, hDC);

	/* rbg}bṽ[h */
	hWht  = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_WHITE));
	hGrn  = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_GREEN));

	EnableWindow(GetDlgItem(hwnd, IDC_STA_0001), FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_0002), FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_0003), FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_0004), FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_0005), FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_0006), FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_0007), FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_0008), FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_DI),   FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_DO),   FALSE);

	hDev = (DWORD)-1;
}

/*	e_CAO鏈 */
void DlgDioUnload(HWND hwnd)
{	
	if(hDev != -1) {
		KillTimer(hwnd, IDM_TMR_READ);	/* ^C}I */
		ct520_CloseDevice(hDev);		/* foCXN[Y */
		hDev = (DWORD)-1;				/* foCXN[YςȂhDev=-1(foCXI[v^N[YԔf̈) */
	}

	DestroyWindow(hwnd);				/* _CAO{bNX */
	hDlg = NULL;						/* _CAO{bNX̃nh */
	ShowWindow(hInx, SW_SHOWDEFAULT);	/* C̃EBhE\ */
}

/* ėpo̓|[gǍ */
void TmrReadIo(HWND hwnd)
{
	WORD	wdt;

	/* ėp̓|[gǍ */
	ct520_rPortW(hDev, INP_PORT, &wdt);

	/* ėp̓|[g\ */
	if(wdt & 1)	SendDlgItemMessage(hwnd, IDC_STA_IN1, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn);
	else		SendDlgItemMessage(hwnd, IDC_STA_IN1, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht);
	if(wdt & 2)	SendDlgItemMessage(hwnd, IDC_STA_IN2, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn);
	else		SendDlgItemMessage(hwnd, IDC_STA_IN2, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht);
	if(wdt & 4)	SendDlgItemMessage(hwnd, IDC_STA_IN3, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn);
	else		SendDlgItemMessage(hwnd, IDC_STA_IN3, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht);
	if(wdt & 8)	SendDlgItemMessage(hwnd, IDC_STA_IN4, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn);
	else		SendDlgItemMessage(hwnd, IDC_STA_IN4, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht);

	/* ėpo̓|[gǍ */
	ct520_rPortW(hDev, OUT_PORT, &wdt);

	/* ėpo̓|[g\ */
	if(wdt & 1)	SendDlgItemMessage(hwnd, IDC_BTN_OUT1, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn);
	else 		SendDlgItemMessage(hwnd, IDC_BTN_OUT1, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL);
	if(wdt & 2)	SendDlgItemMessage(hwnd, IDC_BTN_OUT2, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn);
	else		SendDlgItemMessage(hwnd, IDC_BTN_OUT2, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL);
	if(wdt & 4)	SendDlgItemMessage(hwnd, IDC_BTN_OUT3, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn);
	else		SendDlgItemMessage(hwnd, IDC_BTN_OUT3, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL);
	if(wdt & 8)	SendDlgItemMessage(hwnd, IDC_BTN_OUT4, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn);
	else		SendDlgItemMessage(hwnd, IDC_BTN_OUT4, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL);
}

