/************************************/
/*  HPCI-CTR520F series sample(Vc)	*/
/*	    file name:h_tmr.c			*/
/*      date     :2003/02/20		*/
/*      version  :1.0.0.0 			*/
/************************************/

#include	<windows.h>
#include	"resource.h"
#include	"hictr520.h"
#include	"spct5200.h"

void	DlgTmrLoad  (HWND);
void	DlgTmrUnload(HWND);
void	OpenTmrDev  (HWND);		/* foCXI[v */
void	CloseTmrDev (HWND);		/* foCXN[Y */
void	TmeReadTmr  (HWND);		/* JE^Ǎ^C} */
DWORD	SetTmrData  (HWND);		/* Cxg^C}̐ݒƃX^[g */

/*	foCX֌W̃_CAO{bNX  */
BOOL CALLBACK DlgTmrProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	LPARAM	dummy;
	long	reg;
	char	szBuf[255];
	DWORD	ret;

	dummy = lParam;

	/* _CAO{bNX */
	switch(message) {
		/*  */
		case WM_SHOWWINDOW:	DlgTmrLoad(hwnd);						break;

		/* {^NbN̏ */
		case WM_COMMAND:
			switch (LOWORD(wParam)) {
				/* foCXI[v */
				case IDC_BTN_OPEN:	OpenTmrDev(hwnd);				break;

				/* foCXN[Y */
				case IDC_BTN_CLOS:	CloseTmrDev(hwnd);				break;

				case IDC_BTN_XREAD:	
					sct520_ReadCtr(hDev, X_CH, &reg);
					/* \ */
					wsprintf(szBuf, "%ld ", reg);
					SetDlgItemText(hwnd, IDC_STA_XCTR, szBuf);
					
					sct520_ReadLtc(hDev, X_CH, &reg);
					/* \ */
					wsprintf(szBuf, "%ld ", reg);
					SetDlgItemText(hwnd, IDC_STA_XLTC, szBuf);
																	break;
				case IDC_BTN_YREAD:	
					sct520_ReadCtr(hDev, Y_CH, &reg);
					/* \ */
					wsprintf(szBuf, "%ld ", reg);
					SetDlgItemText(hwnd, IDC_STA_YCTR, szBuf);

					sct520_ReadLtc(hDev, Y_CH, &reg);
					/* \ */
					wsprintf(szBuf, "%ld ", reg);
					SetDlgItemText(hwnd, IDC_STA_YLTC, szBuf);
																	break;
				case IDC_BTN_XCLR:	
					sct520_ClrCtr (hDev, X_CH);		
					sct520_ReadCtr(hDev, X_CH, &reg);
					/* \ */
					wsprintf(szBuf, "%ld ", reg);
					SetDlgItemText(hwnd, IDC_STA_XCTR, szBuf);
																	break;
				case IDC_BTN_YCLR:
					sct520_ClrCtr (hDev, Y_CH);		
					sct520_ReadCtr(hDev, Y_CH, &reg);
					/* \ */
					wsprintf(szBuf, "%ld ", reg);
					SetDlgItemText(hwnd, IDC_STA_YCTR, szBuf);
																	break;
				case IDC_BTN_XSTA:	
					sct520_StrtCtr(hDev, X_CH);	
					EnableWindow(GetDlgItem(hwnd, IDC_BTN_XSTP), TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_BTN_XSTA), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_STA_SLOP), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_STA_SLRD), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT1), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT2), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT4), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_UPDN), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_DIRC), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_MANU), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_AUTO), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_CHK_AUTO), FALSE);
																	break;
				case IDC_BTN_YSTA:	
					sct520_StrtCtr(hDev, Y_CH);	
					EnableWindow(GetDlgItem(hwnd, IDC_BTN_YSTP), TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_BTN_YSTA), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_STA_SLOP), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_STA_SLRD), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT1), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT2), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT4), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_UPDN), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_DIRC), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_MANU), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_AUTO), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_CHK_AUTO), FALSE);					
																	break;
				case IDC_BTN_XSTP:	
					sct520_StopCtr(hDev, X_CH);		
					EnableWindow(GetDlgItem(hwnd, IDC_BTN_XSTP), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_BTN_XSTA), TRUE);
																	break;
				case IDC_BTN_YSTP:	
					sct520_StopCtr(hDev, Y_CH);		
					EnableWindow(GetDlgItem(hwnd, IDC_BTN_YSTP), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_BTN_YSTA), TRUE);
																	break;
				case IDC_BTN_TSTA:	
					ret = SetTmrData(hwnd);
					if(ret) {
						MessageBox(hwnd, "Cxg^C}ݒlG[", "ErrorMessage", MB_OK);
					} else {
						EnableWindow(GetDlgItem(hwnd, IDC_BTN_TSTA),  FALSE);
						EnableWindow(GetDlgItem(hwnd, IDC_BTN_TSTP),  TRUE);

						EnableWindow(GetDlgItem(hwnd, IDC_STA_0004),  FALSE);
						EnableWindow(GetDlgItem(hwnd, IDC_STA_0005),  FALSE);
						EnableWindow(GetDlgItem(hwnd, IDC_STA_0006),  FALSE);

						EnableWindow(GetDlgItem(hwnd, IDC_RAD_WDT1),  FALSE);
						EnableWindow(GetDlgItem(hwnd, IDC_RAD_WDT2),  FALSE);
						EnableWindow(GetDlgItem(hwnd, IDC_RAD_WDT3),  FALSE);

						EnableWindow(GetDlgItem(hwnd, IDC_RAD_TMR1),  FALSE);
						EnableWindow(GetDlgItem(hwnd, IDC_RAD_TMR2),  FALSE);
						EnableWindow(GetDlgItem(hwnd, IDC_RAD_TMR3),  FALSE);
						EnableWindow(GetDlgItem(hwnd, IDC_RAD_TMR4),  FALSE);
						EnableWindow(GetDlgItem(hwnd, IDC_RAD_TMR5),  FALSE);
						EnableWindow(GetDlgItem(hwnd, IDC_RAD_TMR6),  FALSE);
						EnableWindow(GetDlgItem(hwnd, IDC_RAD_TMR7),  FALSE);

						EnableWindow(GetDlgItem(hwnd, IDC_EDT_ETMR),  FALSE);
					}
																	break;				
				case IDC_BTN_TSTP:	
					ct520_wXYReg(hDev, 0x86, 0);

					EnableWindow(GetDlgItem(hwnd, IDC_BTN_TSTA),  TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_BTN_TSTP),  FALSE);

					EnableWindow(GetDlgItem(hwnd, IDC_STA_0004),  TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_STA_0005),  TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_STA_0006),  TRUE);

					EnableWindow(GetDlgItem(hwnd, IDC_RAD_WDT1),  TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_WDT2),  TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_WDT3),  TRUE);

					EnableWindow(GetDlgItem(hwnd, IDC_RAD_TMR1),  TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_TMR2),  TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_TMR3),  TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_TMR4),  TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_TMR5),  TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_TMR6),  TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_TMR7),  TRUE);

					EnableWindow(GetDlgItem(hwnd, IDC_EDT_ETMR),  TRUE);
																	break;
				case IDC_RAD_MLT1:	
					sct520_SelCtrMode(hDev, X_CH, MLT1_NO);
					sct520_SelCtrMode(hDev, Y_CH, MLT1_NO);
																	break;
				case IDC_RAD_MLT2:
					sct520_SelCtrMode(hDev, X_CH, MLT2_NO);
					sct520_SelCtrMode(hDev, Y_CH, MLT2_NO);
																	break;
				case IDC_RAD_MLT4:
					sct520_SelCtrMode(hDev, X_CH, MLT4_NO);
					sct520_SelCtrMode(hDev, Y_CH, MLT4_NO);
																	break;
				case IDC_RAD_UPDN:
					sct520_SelCtrMode(hDev, X_CH, UPDN_NO);
					sct520_SelCtrMode(hDev, Y_CH, UPDN_NO);
																	break;
				case IDC_RAD_DIRC:
					sct520_SelCtrMode(hDev, X_CH, DIRC_NO);
					sct520_SelCtrMode(hDev, Y_CH, DIRC_NO);
																	break;
				case IDC_RAD_MANU:
					if(IsDlgButtonChecked(hwnd, IDC_RAD_MANU) == BST_CHECKED) {
						EnableWindow(GetDlgItem(hwnd, IDC_BTN_XREAD), TRUE);
						EnableWindow(GetDlgItem(hwnd, IDC_BTN_YREAD), TRUE);
					}
																	break;
				case IDC_RAD_AUTO:
					if(IsDlgButtonChecked(hwnd, IDC_RAD_AUTO) == BST_CHECKED) {
						EnableWindow(GetDlgItem(hwnd, IDC_BTN_XREAD), FALSE);
						EnableWindow(GetDlgItem(hwnd, IDC_BTN_YREAD), FALSE);
					}
																	break;
				case IDC_CHK_AUTO:	
					if(IsDlgButtonChecked(hwnd, IDC_CHK_AUTO) == BST_CHECKED) {
						sct520_SetAutoClr(hDev, X_CH, 1);
						sct520_SetAutoClr(hDev, Y_CH, 1);
					} else {
						sct520_SetAutoClr(hDev, X_CH, 0);
						sct520_SetAutoClr(hDev, Y_CH, 0);
					}
																	break;
			}
																	break;	
		/* ^C} */
		case WM_TIMER:
			switch(LOWORD(wParam)) {
				case IDM_TMR_READ:	TmeReadTmr(hwnd);				break;
			}
																	break;		
		/* I */
		case WM_CLOSE:	DlgTmrUnload(hwnd);							break;

		/* I */	
		case WM_DESTROY:	hDlg = NULL;							break;
	}
	return 0;
}
	
/* foCXI[v */
void OpenTmrDev(HWND hwnd)
{
    char	szBuf[255];
	DWORD	ret;

	if(hDev == -1) {
        //{[hI[v
        ret = sct520_OpenID(&hDev, gBrdID);
		if(ret & 0x1000) {
			wsprintf(szBuf, "%s\n%s", "{[h擾s!", 
							"{[h}ĂȂAhCoCXg[ĂȂ̃G[");	
			MessageBox(hwnd, szBuf, "ErrorMessage", MB_OK);
			return;
		} else if(ret & 0x2000) {
			wsprintf(szBuf, "%s\n%s", "{[h擾s!", "VXes̃G[");	
			MessageBox(hwnd, szBuf, "ErrorMessage", MB_OK);
            return;
        } else if(ret & 0x4000) {
			wsprintf(szBuf, "%s%ld%s", "w肵{[hhc ", gBrdID, "̃{[h}Ă܂");
			MessageBox(hwnd, szBuf, "ErrorMessage", MB_OK);
            return;
		} else if(ret & 0x8000) {
			wsprintf(szBuf, "%s\n%s", "foCXI[vs!", "VXes̃G[");	
			MessageBox(hwnd, szBuf, "ErrorMessage", MB_OK);
			return;
		}
        
        // {[h̏
		ret = sct520_InitCtr(hDev);
		if(ret) {
			wsprintf(szBuf, "JE^[s!");	
			MessageBox(hwnd, szBuf, "ErrorMessage", MB_OK);
			DlgTmrUnload(hwnd);
			return;
		}

		/* {^\ */
		EnableWindow(GetDlgItem(hwnd, IDC_STA_XCH),   TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_YCH),   TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_0001),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_0002),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_0003),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_BTN_XREAD), FALSE);
		EnableWindow(GetDlgItem(hwnd, IDC_BTN_YREAD), FALSE);
		EnableWindow(GetDlgItem(hwnd, IDC_BTN_XCLR),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_BTN_YCLR),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_BTN_XSTA),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_BTN_YSTA),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_BTN_TSTA),  TRUE);

		EnableWindow(GetDlgItem(hwnd, IDC_STA_SLOP),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_SLRD),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_ETM1),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_ETM2),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_ETM3),  TRUE);

		EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT1),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT2),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT4),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_UPDN),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_DIRC),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_MANU),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_AUTO),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_CHK_AUTO),  TRUE);

		EnableWindow(GetDlgItem(hwnd, IDC_RAD_WDT1),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_WDT2),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_WDT3),  TRUE);

		EnableWindow(GetDlgItem(hwnd, IDC_RAD_TMR1),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_TMR2),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_TMR3),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_TMR4),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_TMR5),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_TMR6),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_TMR7),  TRUE);

		EnableWindow(GetDlgItem(hwnd, IDC_EDT_ETMR),  TRUE);

		EnableWindow(GetDlgItem(hwnd, IDC_BTN_OPEN),  FALSE);	/* foCXI[v{^gps */
		EnableWindow(GetDlgItem(hwnd, IDC_BTN_CLOS),  TRUE);	/* foCXN[Y{^gp */

		/* WI{^`FbN */
		CheckDlgButton(hwnd, IDC_RAD_MLT4, BST_CHECKED);
		CheckDlgButton(hwnd, IDC_RAD_AUTO, BST_CHECKED);
		CheckDlgButton(hwnd, IDC_RAD_WDT1, BST_CHECKED);
		CheckDlgButton(hwnd, IDC_RAD_TMR7, BST_CHECKED);

		/* GfBbg{bNX̕\ */
		SetDlgItemText(hwnd, IDC_EDT_ETMR,	"1000");
		SendDlgItemMessage(hwnd, IDC_EDT_ETMR, EM_SETLIMITTEXT, 5l, 0l);

		SetTimer(hwnd, IDM_TMR_READ, 100, NULL);		/* ^C}Jn(100msec) */
	}
}

/* foCXN[Y */
void CloseTmrDev(HWND hwnd)
{
	DWORD	ret;

	if(hDev == -1)	return;
	
	KillTimer(hwnd, IDM_TMR_READ);						/* ^C}I */
	ct520_wXYReg(hDev, 0x86, 0);						/* Cxg^C}~ */

	/* ʕ\ */
	CheckDlgButton(hwnd, IDC_RAD_MLT1, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_MLT2, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_MLT4, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_UPDN, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_DIRC, BST_UNCHECKED);

	CheckDlgButton(hwnd, IDC_RAD_MANU, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_AUTO, BST_UNCHECKED);

	CheckDlgButton(hwnd, IDC_CHK_AUTO, BST_UNCHECKED);

	CheckDlgButton(hwnd, IDC_RAD_WDT1, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_WDT2, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_WDT3, BST_UNCHECKED);

	CheckDlgButton(hwnd, IDC_RAD_TMR1, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_TMR2, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_TMR3, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_TMR4, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_TMR5, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_TMR6, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_TMR7, BST_UNCHECKED);

	SetDlgItemText(hwnd, IDC_EDT_ETMR,	"");

	SendDlgItemMessage(hwnd, IDC_STA_XRUN, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL);
	SendDlgItemMessage(hwnd, IDC_STA_YRUN, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL);

	SetDlgItemText(hwnd, IDC_STA_XCTR, "");
	SetDlgItemText(hwnd, IDC_STA_YCTR, "");
	SetDlgItemText(hwnd, IDC_STA_XLTC, "");
	SetDlgItemText(hwnd, IDC_STA_YLTC, "");

	EnableWindow(GetDlgItem(hwnd, IDC_STA_XCH),   FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_YCH),   FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_0001),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_0002),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_0003),  FALSE);

	EnableWindow(GetDlgItem(hwnd, IDC_BTN_XREAD), FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_BTN_YREAD), FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_BTN_XCLR),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_BTN_YCLR),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_BTN_XSTA),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_BTN_YSTA),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_BTN_XSTP),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_BTN_YSTP),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_BTN_TSTA),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_BTN_TSTP),  FALSE);

	EnableWindow(GetDlgItem(hwnd, IDC_STA_SLOP),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_SLRD),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_ETM1),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_ETM2),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_ETM3),  FALSE);

	EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT1),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT2),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT4),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_UPDN),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_DIRC),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_MANU),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_AUTO),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_CHK_AUTO),  FALSE);

	EnableWindow(GetDlgItem(hwnd, IDC_RAD_WDT1),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_WDT2),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_WDT3),  FALSE);

	EnableWindow(GetDlgItem(hwnd, IDC_RAD_TMR1),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_TMR2),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_TMR3),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_TMR4),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_TMR5),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_TMR6),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_TMR7),  FALSE);

	EnableWindow(GetDlgItem(hwnd, IDC_EDT_ETMR),  FALSE);

	EnableWindow(GetDlgItem(hwnd, IDC_BTN_OPEN),  TRUE);	/* foCXI[v{^gp */
	EnableWindow(GetDlgItem(hwnd, IDC_BTN_CLOS),  FALSE);	/* foCXN[Y{^gps */
	
	ret = ct520_CloseDevice(hDev);
	
	/* foCXN[YςȂhDev=-1(foCXI[v^N[YԔf̈) */
	hDev = (DWORD)-1;
}

/* ʏ */
void DlgTmrLoad(HWND hwnd)
{
	HDC		hDC;
	
	/* w肳ꂽEBhẼNCAg̈ɑ΂foCXReLXg̃nh擾 */
	hDC = GetDC(hwnd);

	/* foCXReLXg */
	ReleaseDC(hwnd, hDC);

	/* rbg}bṽ[h */
	hWht  = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_WHITE));
	hGrn  = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_GREEN));

	hDev = (DWORD)-1;
}

/*	e_CAO鏈 */
void DlgTmrUnload(HWND hwnd)
{	
	if(hDev != -1) {
		KillTimer(hwnd, IDM_TMR_READ);	/* ^C}I */
		ct520_CloseDevice(hDev);		/* foCXN[Y */
		hDev = (DWORD)-1;				/* foCXN[YςȂhDev=-1(foCXI[v^N[YԔf̈) */
	}

	DestroyWindow(hwnd);				/* _CAO{bNX */
	hDlg = NULL;						/* _CAO{bNX̃nh */
	ShowWindow(hInx, SW_SHOWDEFAULT);	/* C̃EBhE\ */
}

/* JEglCb`f[^CXe[^XǍ */
void TmeReadTmr(HWND hwnd)
{
	char	szBuf[255];
	WORD	sts;
	long	reg;

	/* Xe[^XǍ */
	ct520_rXYSts(hDev, &sts);

	if((sts & 0x10) && (sts & 0x20)) {
		/* ~̎̓JEg͌`I */
		EnableWindow(GetDlgItem(hwnd, IDC_STA_SLOP), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_SLRD), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT1), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT2), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT4), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_UPDN), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_DIRC), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_MANU), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_AUTO), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_CHK_AUTO), TRUE);
	} else {
		if(IsDlgButtonChecked(hwnd, IDC_RAD_AUTO) == BST_CHECKED) {
			/* JEglǍ */
			sct520_ReadCtr(hDev, X_CH, &reg);
			/* \ */
			wsprintf(szBuf, "%ld ", reg);
			SetDlgItemText(hwnd, IDC_STA_XCTR, szBuf);
					
			/* JEglǍ */
			sct520_ReadCtr(hDev, Y_CH, &reg);
			/* \ */
			wsprintf(szBuf, "%ld ", reg);
			SetDlgItemText(hwnd, IDC_STA_YCTR, szBuf);
			
			/* b`f[^Ǎ */
			sct520_ReadLtc(hDev, X_CH, &reg);
			/* \ */
			wsprintf(szBuf, "%ld ", reg);
			SetDlgItemText(hwnd, IDC_STA_XLTC, szBuf);
					
			/* b`f[^Ǎ */
			sct520_ReadLtc(hDev, Y_CH, &reg);
			/* \ */
			wsprintf(szBuf, "%ld ", reg);
			SetDlgItemText(hwnd, IDC_STA_YLTC, szBuf);
		}
	}

	/* Xe[^X\ */
	if(sts & 0x10) {	/* wbsqJEg~ */
		SendDlgItemMessage(hwnd, IDC_STA_XRUN, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht);
	} else {			/* wbsqJEg */
		SendDlgItemMessage(hwnd, IDC_STA_XRUN, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn);
	}

	if(sts & 0x20) {	/* xbsqJEg~ */
		SendDlgItemMessage(hwnd, IDC_STA_YRUN, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht);
	} else {			/* xbsqJEg */
		SendDlgItemMessage(hwnd, IDC_STA_YRUN, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn);
	}
}

/* Cxg^C}̐ݒƃX^[g */
DWORD SetTmrData(HWND hwnd)
{
	char	szBuf[255];
	WORD	tmrp;
	WORD	cinp;
	DWORD	dwdt;
	DWORD	rnv1;
	DWORD	etmr;

	/* WX^EIvV|[gǍ */
	ct520_rXYReg(hDev, 0xc7,     &rnv1);	/* ݒPǍ */			
	ct520_rPortW(hDev, TMR_PORT, &tmrp);	/* Cxg^C}ݒ|[gǍ */
	ct520_rPortW(hDev, CIN_PORT, &cinp);	/* vo͐ݒ|[gǍ */	
	
	/* XYOUT2o͕ݒ */
	if(IsDlgButtonChecked(hwnd, IDC_RAD_WDT1) == BST_CHECKED) {
		/* 10usec */
		tmrp &= ~0x0010;		/* gOȂ */		
		tmrp |=  0x0001;		/* Cxg^C}M */
		cinp &= ~0x0020;		/* 104msecȂ */
		cinp |=  0x0002;		/* XYOUT2̓Cxg^C}Mo */
	} else if(IsDlgButtonChecked(hwnd, IDC_RAD_WDT2) == BST_CHECKED) {
		/* 104msec */
		tmrp &= ~0x0010;		/* gOȂ */		
		tmrp |=  0x0001;		/* Cxg^C}M */
		cinp |=  0x0020;		/* 104msec */
		cinp |=  0x0002;		/* XYOUT2̓Cxg^C}Mo */
	} else if(IsDlgButtonChecked(hwnd, IDC_RAD_WDT3) == BST_CHECKED) {
		/* duty50%gOo */
		tmrp |=  0x0010;		/* gO */		
		tmrp |=  0x0001;		/* Cxg^C}M */
		cinp &= ~0x0020;		/* 104msecȂ */
		cinp |=  0x0002;		/* XYOUT2̓Cxg^C}Mo */
	}
	
	/* Cxg^C}ȍ͎ */
	if(IsDlgButtonChecked(hwnd, IDC_RAD_TMR1) == BST_CHECKED)		dwdt = 0x10000000;	/* XCTRb` */
	else if(IsDlgButtonChecked(hwnd, IDC_RAD_TMR2) == BST_CHECKED)	dwdt = 0x20000000;	/* XCTRb`&NA */
	else if(IsDlgButtonChecked(hwnd, IDC_RAD_TMR3) == BST_CHECKED)	dwdt = 0x30000000;	/* YCTRb` */
	else if(IsDlgButtonChecked(hwnd, IDC_RAD_TMR4) == BST_CHECKED)	dwdt = 0x40000000;	/* YCTRb`&NA */
	else if(IsDlgButtonChecked(hwnd, IDC_RAD_TMR5) == BST_CHECKED)	dwdt = 0x50000000;	/* XYCTRb` */
	else if(IsDlgButtonChecked(hwnd, IDC_RAD_TMR6) == BST_CHECKED)	dwdt = 0x60000000;	/* XYCTRb`&NA */
	else if(IsDlgButtonChecked(hwnd, IDC_RAD_TMR7) == BST_CHECKED)	dwdt = 0x00000000;	/* Ȃ */
	
	/* ݒP bit28`30*/
	rnv1 &= ~0x70000000;
	rnv1 |=  dwdt;
	
	/* Cxg^C}擾 */
	GetDlgItemText(hwnd, IDC_EDT_ETMR, szBuf, 16);
	etmr = atol(szBuf);	/* Cxg^C}etmr(msec) */

	if(IsDlgButtonChecked(hwnd, IDC_RAD_WDT2) == BST_CHECKED) {
		/* XYOUT2o͕104msec̎̓Cxg^C} */
		/* 105msecȉɐݒs */
		if(etmr < 106) 	return ILL_PARAM;	
	}
	
	etmr *= 100;	/* WX^ݒlFetmr(msec) * 100 */

	/* WX^EIvV|[g */
	ct520_wXYReg(hDev, 0x87,     rnv1);		/* ݒP */			
	ct520_wPortW(hDev, TMR_PORT, tmrp);		/* Cxg^C}ݒ|[g */
	ct520_wPortW(hDev, CIN_PORT, cinp);		/* vo͐ݒ|[g */	
	ct520_wXYReg(hDev, 0x86,     etmr);		/* Cxg^C}X^[g */
	return 0;
}

