/************************************/
/*  HPCI-CTR520F series sample(Vc)	*/
/*	    file name:h_zcl.c			*/
/*      date     :2003/02/20		*/
/*      version  :1.0.0.0 			*/
/************************************/

#include	<windows.h>
#include	"resource.h"
#include	"hictr520.h"
#include	"spct5200.h"

void	DlgZclLoad  (HWND);
void	DlgZclUnload(HWND);
void	OpenZclDev  (HWND);		/* foCXI[v */
void	CloseZclDev (HWND);		/* foCXN[Y */
void	SetZclData	(HWND);		/* JE^NA̐ݒ */
void	TmrReadZcl  (HWND);		/* JE^Ǎ^C} */

/*	foCX֌W̃_CAO{bNX  */
BOOL CALLBACK DlgZclProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	LPARAM	dummy;
	long	reg;
	char	szBuf[255];
	WORD	sts;

	dummy = lParam;

	/* _CAO{bNX */
	switch(message) {
		/*  */
		case WM_SHOWWINDOW:	DlgZclLoad(hwnd);						break;

		/* {^NbN̏ */
		case WM_COMMAND:
			switch (LOWORD(wParam)) {
				/* foCXI[v */
				case IDC_BTN_OPEN:	OpenZclDev(hwnd);				break;

				/* foCXN[Y */
				case IDC_BTN_CLOS:	CloseZclDev(hwnd);				break;

				case IDC_BTN_XREAD:	
					sct520_ReadCtr(hDev, X_CH, &reg);	/* ̊֐spct5200.cɋLqĂ܂ */
					/* \ */
					wsprintf(szBuf, "%ld ", reg);
					SetDlgItemText(hwnd, IDC_STA_XCTR, szBuf);
																	break;
				case IDC_BTN_YREAD:	
					sct520_ReadCtr(hDev, Y_CH, &reg);
					/* \ */
					wsprintf(szBuf, "%ld ", reg);
					SetDlgItemText(hwnd, IDC_STA_YCTR, szBuf);
																	break;
				case IDC_BTN_XCLR:	
					sct520_ClrCtr (hDev, X_CH);		
					sct520_ReadCtr(hDev, X_CH, &reg);
					/* \ */
					wsprintf(szBuf, "%ld ", reg);
					SetDlgItemText(hwnd, IDC_STA_XCTR, szBuf);
																	break;
				case IDC_BTN_YCLR:
					sct520_ClrCtr (hDev, Y_CH);		
					sct520_ReadCtr(hDev, Y_CH, &reg);
					/* \ */
					wsprintf(szBuf, "%ld ", reg);
					SetDlgItemText(hwnd, IDC_STA_YCTR, szBuf);
																	break;
				case IDC_BTN_XSTA:
					/* Xe[^XǍ */
					ct520_rXYSts(hDev, &sts);
					if(sts & 0x20) { 
					/* Ych~Ȃ */
						SetZclData(hwnd);
					}

					sct520_StrtCtr(hDev, X_CH);
					EnableWindow(GetDlgItem(hwnd, IDC_BTN_XSTP), TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_BTN_XSTA), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_STA_SLOP), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_STA_SLRD), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT1), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT2), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT4), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_UPDN), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_DIRC), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_MANU), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_AUTO), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_CHK_XZIN), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_CHK_YZIN), FALSE);
																	break;
				case IDC_BTN_YSTA:
					/* Xe[^XǍ */
					ct520_rXYSts(hDev, &sts);
					if(sts & 0x10) { 
					/* Xch~Ȃ */
						SetZclData(hwnd);
					}

					sct520_StrtCtr(hDev, Y_CH);	
					EnableWindow(GetDlgItem(hwnd, IDC_BTN_YSTP), TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_BTN_YSTA), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_STA_SLOP), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_STA_SLRD), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT1), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT2), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT4), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_UPDN), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_DIRC), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_MANU), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_AUTO), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_CHK_AUTO), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_CHK_XZIN), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_CHK_YZIN), FALSE);
																	break;
				case IDC_BTN_XSTP:
					sct520_StopCtr(hDev, X_CH);
					EnableWindow(GetDlgItem(hwnd, IDC_BTN_XSTP), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_BTN_XSTA), TRUE);
																	break;
				case IDC_BTN_YSTP:
					sct520_StopCtr(hDev, Y_CH);
					EnableWindow(GetDlgItem(hwnd, IDC_BTN_YSTP), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_BTN_YSTA), TRUE);
																	break;
				case IDC_RAD_MLT1:	
					sct520_SelCtrMode(hDev, X_CH, MLT1_NO);
					sct520_SelCtrMode(hDev, Y_CH, MLT1_NO);
																	break;
				case IDC_RAD_MLT2:
					sct520_SelCtrMode(hDev, X_CH, MLT2_NO);
					sct520_SelCtrMode(hDev, Y_CH, MLT2_NO);
																	break;
				case IDC_RAD_MLT4:
					sct520_SelCtrMode(hDev, X_CH, MLT4_NO);
					sct520_SelCtrMode(hDev, Y_CH, MLT4_NO);
																	break;
				case IDC_RAD_UPDN:
					sct520_SelCtrMode(hDev, X_CH, UPDN_NO);
					sct520_SelCtrMode(hDev, Y_CH, UPDN_NO);
																	break;
				case IDC_RAD_DIRC:
					sct520_SelCtrMode(hDev, X_CH, DIRC_NO);
					sct520_SelCtrMode(hDev, Y_CH, DIRC_NO);
																	break;
				case IDC_RAD_MANU:
					if(IsDlgButtonChecked(hwnd, IDC_RAD_MANU) == BST_CHECKED) {
						EnableWindow(GetDlgItem(hwnd, IDC_BTN_XREAD), TRUE);
						EnableWindow(GetDlgItem(hwnd, IDC_BTN_YREAD), TRUE);
					}
																	break;
				case IDC_RAD_AUTO:
					if(IsDlgButtonChecked(hwnd, IDC_RAD_AUTO) == BST_CHECKED) {
						EnableWindow(GetDlgItem(hwnd, IDC_BTN_XREAD), FALSE);
						EnableWindow(GetDlgItem(hwnd, IDC_BTN_YREAD), FALSE);
					}
																	break;
				case IDC_CHK_AUTO:	
					if(IsDlgButtonChecked(hwnd, IDC_CHK_AUTO) == BST_CHECKED) {
						sct520_SetAutoClr(hDev, X_CH, 1);
						sct520_SetAutoClr(hDev, Y_CH, 1);
					} else {
						sct520_SetAutoClr(hDev, X_CH, 0);
						sct520_SetAutoClr(hDev, Y_CH, 0);
					}
																	break;
			}
																	break;	
		/* ^C} */
		case WM_TIMER:
			switch(LOWORD(wParam)) {
				case IDM_TMR_READ:	TmrReadZcl(hwnd);				break;
			}
																	break;		
		/* I */
		case WM_CLOSE:	DlgZclUnload(hwnd);							break;

		/* I */
		case WM_DESTROY:	hDlg = NULL;							break;
	}
	return 0;
}

	
/* foCXI[v */
void OpenZclDev(HWND hwnd)
{
    char	szBuf[255];
	DWORD	ret;

	if(hDev == -1) {
        //{[hI[v
        ret = sct520_OpenID(&hDev, gBrdID);
		if(ret & 0x1000) {
			wsprintf(szBuf, "%s\n%s", "{[h擾s!", 
							"{[h}ĂȂAhCoCXg[ĂȂ̃G[");	
			MessageBox(hwnd, szBuf, "ErrorMessage", MB_OK);
			return;
		} else if(ret & 0x2000) {
			wsprintf(szBuf, "%s\n%s", "{[h擾s!", "VXes̃G[");	
			MessageBox(hwnd, szBuf, "ErrorMessage", MB_OK);
            return;
        } else if(ret & 0x4000) {
			wsprintf(szBuf, "%s%ld%s", "w肵{[hhc ", gBrdID, "̃{[h}Ă܂");
			MessageBox(hwnd, szBuf, "ErrorMessage", MB_OK);
            return;
		} else if(ret & 0x8000) {
			wsprintf(szBuf, "%s\n%s", "foCXI[vs!", "VXes̃G[");	
			MessageBox(hwnd, szBuf, "ErrorMessage", MB_OK);
			return;
		}
        
        // {[h̏
		ret = sct520_InitCtr(hDev);
		if(ret) {
			wsprintf(szBuf, "JE^[s!");	
			MessageBox(hwnd, szBuf, "ErrorMessage", MB_OK);
			DlgZclUnload(hwnd);
			return;
		}

		/* {^\ */
		EnableWindow(GetDlgItem(hwnd, IDC_STA_XCH),   TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_YCH),   TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_0001),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_0002),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_BTN_XREAD), FALSE);
		EnableWindow(GetDlgItem(hwnd, IDC_BTN_YREAD), FALSE);
		EnableWindow(GetDlgItem(hwnd, IDC_BTN_XCLR),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_BTN_YCLR),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_BTN_XSTA),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_BTN_YSTA),  TRUE);

		EnableWindow(GetDlgItem(hwnd, IDC_STA_SLOP),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_SLRD),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT1),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT2),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT4),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_UPDN),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_DIRC),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_MANU),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_AUTO),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_CHK_AUTO),  TRUE);

		EnableWindow(GetDlgItem(hwnd, IDC_CHK_XZIN),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_CHK_YZIN),  TRUE);

		EnableWindow(GetDlgItem(hwnd, IDC_BTN_OPEN),  FALSE);	/* foCXI[v{^gps */
		EnableWindow(GetDlgItem(hwnd, IDC_BTN_CLOS),  TRUE);	/* foCXN[Y{^gp */

		/* WI{^`FbN */
		CheckDlgButton(hwnd, IDC_RAD_MLT4, BST_CHECKED);
		CheckDlgButton(hwnd, IDC_RAD_AUTO, BST_CHECKED);
		
		SetTimer(hwnd, IDM_TMR_READ, 100, NULL);		/* ^C}Jn(100msec) */
	}
}

/* foCXN[Y */
void CloseZclDev(HWND hwnd)
{
	DWORD	ret;

	if(hDev == -1)	return;
	
	KillTimer(hwnd, IDM_TMR_READ);						/* ^C}I */

	/* ʕ\ */
	CheckDlgButton(hwnd, IDC_RAD_MLT1, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_MLT2, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_MLT4, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_UPDN, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_DIRC, BST_UNCHECKED);

	CheckDlgButton(hwnd, IDC_RAD_MANU, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_AUTO, BST_UNCHECKED);

	CheckDlgButton(hwnd, IDC_CHK_AUTO, BST_UNCHECKED);

	CheckDlgButton(hwnd, IDC_CHK_XZIN, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_CHK_YZIN, BST_UNCHECKED);

	SendDlgItemMessage(hwnd, IDC_STA_XRUN, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL);
	SendDlgItemMessage(hwnd, IDC_STA_YRUN, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL);

	SetDlgItemText(hwnd, IDC_STA_XCTR, "");
	SetDlgItemText(hwnd, IDC_STA_YCTR, "");

	EnableWindow(GetDlgItem(hwnd, IDC_STA_XCH),   FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_YCH),   FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_0001),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_0002),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_BTN_XREAD), FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_BTN_YREAD), FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_BTN_XCLR),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_BTN_YCLR),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_BTN_XSTA),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_BTN_YSTA),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_BTN_XSTP),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_BTN_YSTP),  FALSE);

	EnableWindow(GetDlgItem(hwnd, IDC_STA_SLOP),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_SLRD),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT1),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT2),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT4),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_UPDN),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_DIRC),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_MANU),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_AUTO),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_CHK_AUTO),  FALSE);
	
	EnableWindow(GetDlgItem(hwnd, IDC_CHK_XZIN),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_CHK_YZIN),  FALSE);
	
	EnableWindow(GetDlgItem(hwnd, IDC_BTN_OPEN),  TRUE);	/* foCXI[v{^gp */
	EnableWindow(GetDlgItem(hwnd, IDC_BTN_CLOS),  FALSE);	/* foCXN[Y{^gps */
	
	ret = ct520_CloseDevice(hDev);
	
	/* foCXN[YςȂhDev=-1(foCXI[v^N[YԔf̈) */
	hDev = (DWORD)-1;
}

/* ʏ */
void DlgZclLoad(HWND hwnd)
{
	HDC		hDC;
	
	/* w肳ꂽEBhẼNCAg̈ɑ΂foCXReLXg̃nh擾 */
	hDC = GetDC(hwnd);

	/* foCXReLXg */
	ReleaseDC(hwnd, hDC);

	/* rbg}bṽ[h */
	hWht  = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_WHITE));
	hGrn  = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_GREEN));

	hDev = (DWORD)-1;
}

/*	e_CAO鏈 */
void DlgZclUnload(HWND hwnd)
{	
	if(hDev != -1) {
		KillTimer(hwnd, IDM_TMR_READ);	/* ^C}I */
		ct520_CloseDevice(hDev);		/* foCXN[Y */
		hDev = (DWORD)-1;				/* foCXN[YςȂhDev=-1(foCXI[v^N[YԔf̈) */
	}

	DestroyWindow(hwnd);				/* _CAO{bNX */
	hDlg = NULL;						/* _CAO{bNX̃nh */
	ShowWindow(hInx, SW_SHOWDEFAULT);	/* C̃EBhE\ */
}

/* JEglCXe[^XǍ */
void TmrReadZcl(HWND hwnd)
{
	char	szBuf[255];
	WORD	sts;
	long	reg;

	/* Xe[^XǍ */
	ct520_rXYSts(hDev, &sts);

	if((sts & 0x10) && (sts & 0x20)) {
		/* ~̎̓JEg͌`I */
		EnableWindow(GetDlgItem(hwnd, IDC_STA_SLOP), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_SLRD), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT1), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT2), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT4), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_UPDN), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_DIRC), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_MANU), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_AUTO), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_CHK_AUTO), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_CHK_XZIN), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_CHK_YZIN), TRUE);
	}

	if(IsDlgButtonChecked(hwnd, IDC_RAD_AUTO) == BST_CHECKED) {
		/* JEglǍ */
		sct520_ReadCtr(hDev, X_CH, &reg);
		/* \ */
		wsprintf(szBuf, "%ld ", reg);
		SetDlgItemText(hwnd, IDC_STA_XCTR, szBuf);
				
		/* JEglǍ */
		sct520_ReadCtr(hDev, Y_CH, &reg);
		/* \ */
		wsprintf(szBuf, "%ld ", reg);
		SetDlgItemText(hwnd, IDC_STA_YCTR, szBuf);
	}

	/* Xe[^X\ */
	if(sts & 0x10) {	/* wbsqJEg~ */
		SendDlgItemMessage(hwnd, IDC_STA_XRUN, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht);
	} else {			/* wbsqJEg */
		SendDlgItemMessage(hwnd, IDC_STA_XRUN, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn);
	}

	if(sts & 0x20) {	/* xbsqJEg~ */
		SendDlgItemMessage(hwnd, IDC_STA_YRUN, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht);
	} else {			/* xbsqJEg */
		SendDlgItemMessage(hwnd, IDC_STA_YRUN, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn);
	}
}

/* y͂ɂJE^NA̐ݒ */
void SetZclData(HWND hwnd)
{
	WORD  clrp;
	DWORD rnv1;
	
	ct520_rXYReg(hDev, 0xc7, &rnv1);
	rnv1 |= 0x000c0000;
	ct520_wXYReg(hDev, 0x87,  rnv1);		/* ݒPݒ(JE^NA) */
	ct520_rPortW(hDev, CLR_PORT, &clrp);	/* JE^NAݒ|[gǍ */
	
	if(IsDlgButtonChecked(hwnd, IDC_CHK_XZIN) == BST_CHECKED) {
		rnv1 &= ~0x00040000;	/* ݒPݒ(Z̓JE^NAL) */
		clrp |=  0x0001;		/* XchZXchJE^NA */
	} else {
		clrp &= ~0x0001;		/* XchZXchJE^NA */
	}

	if(IsDlgButtonChecked(hwnd, IDC_CHK_YZIN) == BST_CHECKED) {
		rnv1 &= ~0x00080000;	/* ݒPݒ(Z̓JE^NAL) */
		clrp |=  0x0002;		/* YchZYchJE^NA */
	} else {
		clrp &= ~0x0002;		/* YchZYchJE^NA */
	}
	ct520_wXYReg(hDev, 0x87, rnv1);			/* ݒP */
	ct520_wPortW(hDev, CLR_PORT, clrp);		/* JE^NAݒ|[g */
}




