/************************************/
/*  HPCI-CTR520F series sample(Vc)	*/
/*	    file name:spct5200.c		*/
/*      date     :2003/02/20		*/
/*      version  :1.0.0.0 			*/
/************************************/

#include	<windows.h>
#include	"resource.h"
#include	"hictr520.h"
#include	"spct5200.h"

/* w肵{[h̃I[v */
DWORD sct520_OpenID(DWORD* hDevID, DWORD BrdID)
{
    DWORD			n, ret, cnt, hDev;
	HPCDEVICEINFO	hInf[CNTMAX];
	HPCDEVICEINFO	hInf2; 
    
    //{[h擾
    ret = ct520_GetDeviceCount(&cnt);

    //{[h 0,17ȏ ܂ ߂l "0" ̎G[
    if((cnt == 0) || (cnt > CNTMAX) || (ret != 0))	return 0x1000;

    //foCX擾
    ret = ct520_GetDeviceInfo(&cnt, &hInf[0]);		
    if(ret)											return 0x2000;
        
    // {[hIDw
    for(n = 0; n < cnt; n++) {
        if(hInf[n].dwBoardID == BrdID) {
            hInf2 = hInf[n];
            break;
        } else {
            hInf2.dwBoardID = hInf[n].dwBoardID;
        }
    }
    
    if(hInf2.dwBoardID != BrdID)					return 0x4000;
    
    ret = ct520_OpenDevice(&hDev, &hInf2);
    if(ret) {
        ret = ct520_CloseDevice(hDev);
        hDev = (DWORD)-1;
													return 0x8000;
    } else {
        *hDevID = hDev;
													return 0;
	}
}

/****************************************************************/
/*	{[h̏												*/
/*		HPCI-CTR520F̏܂B					*/
/*		gpɍ킹ēKXf[^ύXĂB	*/
/****************************************************************/
DWORD sct520_InitCtr(DWORD hDevID)
{
	DWORD	ret;
	DWORD	reg;

/* 1. #1CCLWX^ݒ */
	/* 1.1 \tgEFAZbg : ĳؾĎw߂őSĂڼ޽͂Oر */
	ct520_wXYCmd(hDevID, 0x40);				/* ȍ~̊eڼ޽̏͊mF

	/* 1.2 #1CCL WX^P(͎dl,̑) */
#define		RENV1	0x0acc3012L	/* WX^Pݒl */
			/* b31   (0   ):ϒ[qo:_(ްގd:Œ) */
			/* b30-28( 000):Ϗo͎FȂ */
			/* b27   (1   ):ڰ4:YCTR */
			/* b26   ( 0  ):ڰ3:XCTR */
			/* b25   (  1 ):ڰ2:YCTR */
			/* b24   (   0):ڰ1:XCTR */
			/* b23-21(110 ):DSBnͶĒ~:  (ްގdl:Œ) */
			/* b20   (   0):LTCn͘_=贯(ްގdl:Œ) */
			/* b19   (1   ):YZͶر: */
			/* b18   ( 1  ):XZͶر: */
			/* b17-16(  00):YZ,XZ͸ر:贯 */
			/* b15   (0   ):YCTRǏo̎ر:Ȃ */
			/* b14   ( 0  ):XCTRǏo̎ر:Ȃ */
			/* b13   (  1 ):YCTR~ */
			/* b12   (   1):XCTR~ */
			/* b11-10(00  ):YCTRފԑI(`) */
			/* b 9- 8(  00):YCTRފԑJn(`) */
			/* b 7   (0   ):YCTR:޳ݶ */
			/* b 6   ( 0  ):YCTR=YA,YB */
			/* b 5- 3( 010):YA,YB=90߈ʑS{ */
			/* b 2- 0( 010):XA,XB=90߈ʑS{ */
	ct520_wXYReg(hDevID, 0x87, RENV1);
	ct520_rXYReg(hDevID, 0xc7, &reg);			/*  ƍǍ */
	if(reg != RENV1) 		return 1;

	/* 1.3 #1CCL WX^Q(ڰ,̑) */
#define		RENV2	0x1005ff00L	/* WX^Qݒl */
			/* b31-30(00  ):(CCLdl) */
			/* b29   (  0 ):XA,XB,YA,YB̨nm */
			/* b28   (   1):CMPOUT1,2o:Ͻ() */
			/* b27-24(0000):P0-3[q=ėp(ްގdl:Œ) */
			/* b23   (0   ):CMPOUT3,4[qo͘_=_ */
			/* b22   ( 0  ):CMPOUT1,2[qo͘_=_ */
			/* b21   (  0 ):CMPOUT2o͂"="r=Ȃ */
			/* b20   (   0):CMPOUT1o͂"="r=Ȃ */
			/* b19-18(01  ):CMPOUT3,4o͐Mٽ=ݼ50us */
			/* b17-16(  01):CMPOUT1,2o͐Mٽ=ݼ50us */
			/* b15-12(1111):CMPOUT4o͂̔r@=ɕs */
			/* b11- 8(1111):CMPOUT3o͂̔r@=ɕs */
			/* b 7- 4(0000):CMPOUT2o͂̔r@=RCMP1<r */
			/* b 3- 0(0000):CMPOUT1o͂̔r@=RCMP1<r */
	ct520_wXYReg(hDevID, 0x88, RENV2);
	ct520_rXYReg(hDevID, 0xc8, &reg);			/*  ƍǍ */
	if(reg != RENV2)			return 1;

	/* 1.4 #1CCL JE^P */
	ct520_wXYReg(hDevID, 0x80, 0);			/* JE^PO */
	ct520_rXYReg(hDevID, 0xc0, &reg);			/*  ƍǍ */
	if(reg) 					return 1;

	/* 1.5 #1CCL JE^Q */
	ct520_wXYReg(hDevID, 0x81, 0);			/* JE^QO */
	ct520_rXYReg(hDevID, 0xc1, &reg);			/*  ƍǍ */
	if(reg) 					return 1;

	/* 1.6 #1CCL rf[^WX^P */
#define		WIND_N	-5000L					/* ޺ڰ:RCMP1 */
	ct520_wXYReg(hDevID, 0x82, WIND_N);		/* rf[^WX^P= WIND_N */
	ct520_rXYReg(hDevID, 0xc2, &reg);			/*  ƍǍ */
	if(reg!=WIND_N)				return 1;

	/* 1.7 #1CCL rf[^WX^Q */
#define		WIND_P	 5000L					/* ޺ڰ:RCMP2 */
	ct520_wXYReg(hDevID, 0x83, WIND_P);		/* rf[^WX^Q= WIND_P */
	ct520_rXYReg(hDevID, 0xc3, &reg);			/*  ƍǍ */
	if(reg!=WIND_P) 			return 1;

	/* 1.8 #1CCL rf[^WX^R */
	ct520_wXYReg(hDevID, 0x84, 0);			/* rf[^WX^RO */
	ct520_rXYReg(hDevID, 0xc4, &reg);			/*  ƍǍ */
	if(reg) 					return 1;

	/* 1.9 #1CCL rf[^WX^S */
	ct520_wXYReg(hDevID, 0x85, 0);			/* rf[^WX^SO */
	ct520_rXYReg(hDevID, 0xc5, &reg);			/*  ƍǍ */
	if(reg) 					return 1;

	/* 1.10 #1CCL Cxg^C}WX^ */
	ct520_wXYReg(hDevID, 0x86, 0);			/* Cxg^C}WX^O */
	ct520_rXYReg(hDevID, 0xc6, &reg);			/*  ƍǍ */
	if(reg) 					return 1;

	/* 1.11 #1CCL vݒ背WX^ */
			/* b31-28(0000):sgp */
			/* b27   (0   ):sgp */
			/* b26   ( 0  ):(ITM):gpJnƎw莞Ԍoߖ */
			/* b25   (  0 ):YCTR:MaxMin蒆(=0x4a)ɑIތo(RENV1:b11-10) */
			/* b24   (   0):߼߰ēׯ(0x18)ݒɂ铯ׯ */
			/* b23   (0   ):YCTR -ް۰ */
			/* b22   ( 0  ):YCTR +ް۰ */
			/* b21   (  0 ):XCTR -ް۰ */
			/* b20   (   0):XCTR +ް۰ */
			/* b19   (0   ):YAYB͐Mُ픭(ω) */
			/* b18   ( 0  ):XAXB͐Mُ픭(ω) */
			/* b17   (  0 ):YCTR<>0 ==> YCTR=0 */
			/* b16   (   0):XCTR<>0 ==> XCTR=0 */
			/* b15-12(0000):sgp(\) */
			/* b11-10(00  ):sgp(\) */
			/* b 9   (  0 ):߼߰YZر(0x19:b1)ݒɂ鶳ر */
			/* b 8   (   0):߼߰XZر(0x19:b0)ݒɂ鶳ر */
			/* b 7   (0   ):CMPOUT4o͏  ==>s */
			/* b 6   ( 0  ):CMPOUT4o͏s==>   */
			/* b 5   (  0 ):CMPOUT3o͏  ==>s */
			/* b 4   (   0):CMPOUT3o͏s==>   */
			/* b 3   (0   ):CMPOUT2o͏  ==>s */
			/* b 2   ( 0  ):CMPOUT2o͏s==>   */
			/* b 1   (  0 ):CMPOUT1o͏  ==>s */
			/* b 0   (   0):CMPOUT1o͏s==>   */
	ct520_wXYReg(hDevID, 0x89, 0);			/*  all off */
	ct520_rXYReg(hDevID, 0xc9, &reg);			/*  ƍǍ */
	if(reg) 					return 1;

	ct520_wZUCmd(hDev, 0x40);
	ct520_rZUReg(hDev, 0xc0, &reg);	
	if(!reg) {	/* #2 CCL(ZUch)̃WX^"0"œǂ߂HPCI-CTR524F */
	/* 2. #2CCLWX^ݒ */
	/* 2.1 \tgEFAZbg : ĳؾĎw߂őSĂڼ޽͂Oر */
		ct520_wZUCmd(hDevID, 0x40);				/* ȍ~̊eڼ޽̏͊mF

		/* 2.2 #2CCL WX^P(͎dl,̑) */
		/* #1CCLƓl̐ݒ */
		ct520_wZUReg(hDevID, 0x87, RENV1);
		ct520_rZUReg(hDevID, 0xc7, &reg);			/*  ƍǍ */
		if(reg != RENV1) 		return 1;

		/* 2.3 #2CCL WX^Q(ڰ,̑) */
		/* #1CCLƓl̐ݒ */
		ct520_wZUReg(hDevID, 0x88, RENV2);
		ct520_rZUReg(hDevID, 0xc8, &reg);			/*  ƍǍ */
		if(reg != RENV2)			return 1;

		/* 2.4 #2CCL JE^P */
		ct520_wZUReg(hDevID, 0x80, 0);			/* JE^PO */
		ct520_rZUReg(hDevID, 0xc0, &reg);			/*  ƍǍ */
		if(reg) 					return 1;

		/* 2.5 #2CCL JE^Q */
		ct520_wZUReg(hDevID, 0x81, 0);			/* JE^QO */
		ct520_rZUReg(hDevID, 0xc1, &reg);			/*  ƍǍ */
		if(reg) 					return 1;

		/* 2.6 #2CCL rf[^WX^P */
		/* #1CCLƓl̐ݒ */
		ct520_wZUReg(hDevID, 0x82, WIND_N);		/* rf[^WX^P= WIND_N */
		ct520_rZUReg(hDevID, 0xc2, &reg);			/*  ƍǍ */
		if(reg!=WIND_N)				return 1;

		/* 2.7 #2CCL rf[^WX^Q */
		/* #1CCLƓl̐ݒ */
		ct520_wZUReg(hDevID, 0x83, WIND_P);		/* rf[^WX^Q= WIND_P */
		ct520_rZUReg(hDevID, 0xc3, &reg);			/*  ƍǍ */
		if(reg!=WIND_P) 			return 1;

		/* 2.8 #2CCL rf[^WX^R */
		ct520_wZUReg(hDevID, 0x84, 0);			/* rf[^WX^RO */
		ct520_rZUReg(hDevID, 0xc4, &reg);			/*  ƍǍ */
		if(reg) 					return 1;

		/* 2.9 #2CCL rf[^WX^S */
		ct520_wZUReg(hDevID, 0x85, 0);			/* rf[^WX^SO */
		ct520_rZUReg(hDevID, 0xc5, &reg);			/*  ƍǍ */
		if(reg) 					return 1;

		/* 2.10 #2CCL Cxg^C}WX^ */
		ct520_wZUReg(hDevID, 0x86, 0);			/* Cxg^C}WX^O */
		ct520_rZUReg(hDevID, 0xc6, &reg);			/*  ƍǍ */
		if(reg) 					return 1;

		/* 2.11 #2CCL vݒ背WX^ */
		ct520_wZUReg(hDevID, 0x89, 0);			/*  all off */
		ct520_rZUReg(hDevID, 0xc9, &reg);			/*  ƍǍ */
		if(reg) 					return 1;
	}

/* 3. o̓|[g & IvV|[gݒ */
	ret = sct520_InitOpt(hDevID);
	if(ret) 					return 1;	/* error */
	else						return 0;
}

/****************************************************************/
/*	o̓|[gƃIvV|[g̏						*/
/*		HPCI-CTR520F̃IvV|[g̏܂B	*/
/*		gpɍ킹ēKXf[^ύXĂB	*/
/****************************************************************/
DWORD sct520_InitOpt(DWORD hDevID)
{
	BYTE	bdt;
	WORD	wdt;

/* o̓|[g & IvV|[gݒ */
	/* 1 ėpo̓|[gNA */
	ct520_wPortB(hDevID, OUT_PORT, 0);		/* write(0) */
	ct520_rPortB(hDevID, OUT_PORT, &bdt);		/*  ƍǍ */
	bdt &= 0x0f;							/* mask */
	if(bdt) 					return 1;	/* verify error */

	/* 2 CMPo͐ݒ|[gFo͂Ȃ */
	ct520_wPortW(hDevID, CMP_PORT, 0);		/* write(0) */
	ct520_rPortW(hDevID, CMP_PORT, &wdt);		/*  ƍǍ */
	wdt &= 0x00ff;							/* mask */
	if(wdt)						return 1;	/* verify error */

	/* 3 TMRo͐ݒ|[gFo͂Ȃ */
	ct520_wPortW(hDevID, TMR_PORT, 0);		/* write(0) */
	ct520_rPortW(hDevID, TMR_PORT, &wdt);		/*  ƍǍ */
	wdt &= 0x0033;							/* mask */
	if(wdt)						return 1;	/* verify error */

	/* 4 vo͐ݒ|[g(XYOUT1, ZUOUT1o͕104msec) */
	ct520_wPortW(hDevID, CIN_PORT, 0x30);	/* write */
	ct520_rPortW(hDevID, CIN_PORT, &wdt);		/*  ƍǍ */
	wdt &= 0x00ff;							/* mask */
	if(wdt != 0x30)				return 1;	/* verify error */

	/* 5 JE^NAݒ|[gݒFy͂ɂJE^NAȂ */
	ct520_wPortW(hDevID, CLR_PORT, 0);		/* write */
	ct520_rPortW(hDevID, CLR_PORT, &wdt);		/*  ƍǍ */
	wdt &= 0x000f;							/* mask */
	if(wdt) 					return 1;	/* verify error */

	/* 6 b`ݒ|[gݒFb`Ȃ */
	ct520_wPortW(hDevID, LTC_PORT, 0);		/* write */
	ct520_rPortW(hDevID, LTC_PORT, &wdt);		/*  ƍǍ */
	wdt &= 0x00ff;							/* mask */
	if(wdt) 					return 1;	/* verify error */

	/* 7 }XN() */
	ct520_wPortW(hDevID, INT_PORT, 0);		/* write */
	ct520_rPortW(hDevID, INT_PORT, &wdt);		/*  ƍǍ */
	wdt &= 0x0007;							/* mask */
	if(wdt) 					return 1;	/* verify error */

	/* 8 }XN(PCI) */
	ct520_wPortW(hDevID, PCI_PORT, 0);		/* write */
	ct520_rPortW(hDevID, PCI_PORT, &wdt);		/*  ƍǍ */
	wdt &= 0x0001;							/* mask */
	if(wdt) 					return 1;	/* verify error */
	else						return 0;
}

/****************************************************/
/* JE^͌`̑I							*/
/*   hDevID FfoCXnh						*/
/*   ch   F`l(0:Xch, 1:Ych, 2:Zch, 3:Uch)	*/
/*   md   FJE^͌`(O`T)				*/
/*			 0:x1, 1:x2, 2:x4, 3:U/D, 5:ٽ	*/
/*		ڼ޽P: Ych(Uch)=b5-b3,Xch(Zch)=b2-b0	*/
/****************************************************/
void sct520_SelCtrMode(DWORD hDevID, WORD ch, WORD md)
{
	DWORD	reg;

	if(ch < 2) {
		ct520_rXYReg(hDevID, 0xc7, &reg);		/* WX^P */
		switch(ch) {
		  case X_CH: reg &= ~0x00000007L;	reg |= md;		break;	/* b2-b0 */
		  case Y_CH: reg &= ~0x00000038L;	reg |= md << 3;	break;	/* b5-b3 */
		}
		ct520_wXYReg(hDevID, 0x87, reg);		/* WX^P */
	} else if(ch < 4) {
		ct520_rZUReg(hDevID, 0xc7, &reg);		/* WX^P */
		switch(ch) {
		  case Z_CH: reg &= ~0x00000007L;	reg |= md;		break;	/* b2-b0 */
		  case U_CH: reg &= ~0x00000038L;	reg |= md << 3;	break;	/* b5-b3 */
		}
		ct520_wZUReg(hDevID, 0x87, reg);		/* WX^P */
	}
}

/****************************************************/
/* JE^ǏõJE^NAݒ				*/
/*   @\ FJE^Ǐo, JE^NA܂B*/
/*   hDevID FfoCXnh						*/
/*   ch   F`l(0:Xch, 1:Ych, 2:Zch, 3:Uch)	*/
/*   sel  FJE^NA(1) / Ȃ(0)		*/
/*		ڼ޽P: Ych,Uch=b15,Xch,Zch=b14		*/
/****************************************************/
void sct520_SetAutoClr(DWORD hDevID, WORD ch, WORD sel)
{
	DWORD	reg;

	if(ch < 2) {
		ct520_rXYReg(hDevID, 0xc7, &reg);			/* WX^P */
		switch(ch) {
		  case X_CH: if(sel) reg |=  0x00004000L;	/*  b14=1 */
					 else	 reg &= ~0x00004000L;	/*  b14=0 */
					 break;
		  case Y_CH: if(sel) reg |=  0x00008000L;	/*  b15=1 */
					 else	 reg &= ~0x00008000L;	/*  b15=0 */
					 break;
		}
		ct520_wXYReg(hDevID, 0x87,  reg);			/* WX^P */
	} else if(ch < 4) {
		ct520_rZUReg(hDevID, 0xc7, &reg);			/* WX^P */
		switch(ch) {
		  case Z_CH: if(sel) reg |=  0x00004000L;	/*  b14=1 */
					 else	 reg &= ~0x00004000L;	/*  b14=0 */
					 break;
		  case U_CH: if(sel) reg |=  0x00008000L;	/*  b15=1 */
					 else	 reg &= ~0x00008000L;	/*  b15=0 */
					 break;
		}
		ct520_wZUReg(hDevID, 0x87,  reg);			/* WX^P */
	}
}

/****************************************************/
/* JEgX^[g									*/
/*   @\ FJEgJn܂B					*/
/*   hDevID FfoCXnh						*/
/*   ch   F`l(0:Xch, 1:Ych, 2:Zch, 3:Uch)	*/
/*		ڼ޽P: Ych(Uch):b13=0, Xch(Zch):b12=0	*/
/****************************************************/
void sct520_StrtCtr(DWORD hDevID, WORD ch)
{
	DWORD	reg;

	if(ch < 2) {
		ct520_rXYReg(hDevID, 0xc7, &reg);		/* WX^P */
		switch(ch) {
		  case X_CH: reg &= ~0x00001000L;	break;	/*  b12=0 */
		  case Y_CH: reg &= ~0x00002000L;	break;	/*  b13=0 */
		}
		ct520_wXYReg(hDevID, 0x87,  reg);		/* WX^P */
	} else if(ch < 4) {
		ct520_rZUReg(hDevID, 0xc7, &reg);		/* WX^P */
		switch(ch) {
		  case Z_CH: reg &= ~0x00001000L;	break;	/*  b12=0 */
		  case U_CH: reg &= ~0x00002000L;	break;	/*  b13=0 */
		}
		ct520_wZUReg(hDevID, 0x87,  reg);		/* WX^P */
	}
}

/****************************************************/
/* JEgXgbv									*/
/*   @\ FJEg~܂B					*/
/*   hDevID FfoCXnh						*/
/*   ch   F`l(0:Xch, 1:Ych, 2:Zch, 3:Uch)	*/
/*		ڼ޽P: Ych,Uch=b13,Xch,Zch=b12		*/
/****************************************************/
void sct520_StopCtr(DWORD hDevID, WORD ch)
{
	DWORD	reg;

	if(ch < 2) {
		ct520_rXYReg(hDevID, 0xc7, &reg);		/* WX^P */
		switch(ch) {
		  case X_CH: reg |=  0x00001000L;	break;	/*  b12=1 */
		  case Y_CH: reg |=  0x00002000L;	break;	/*  b13=1 */
		}
		ct520_wXYReg(hDevID, 0x87,  reg);		/* WX^P */
	} else if(ch < 4) {
		ct520_rZUReg(hDevID, 0xc7, &reg);		/* WX^P */
		switch(ch) {
		  case Z_CH: reg |=  0x00001000L;	break;	/*  b12=1 */
		  case U_CH: reg |=  0x00002000L;	break;	/*  b13=1 */
		}
		ct520_wZUReg(hDevID, 0x87,  reg);		/* WX^P */
	}
}

/****************************************************/
/* JE^Ǎ										*/
/*   @\ FJEgǍ݂܂B					*/
/*   hDevID FfoCXnh						*/
/*   ch   F`l(0:Xch, 1:Ych, 2:Zch, 3:Uch)	*/
/*   ctr  FJE^̒l							*/
/*    Ǎ Xch,Zch=0xc0, Ych,Uch=0xc1			*/
/****************************************************/
void sct520_ReadCtr(DWORD hDevID, WORD ch, long* ctr)
{
	if(ch<2)      ct520_rXYReg(hDevID, (WORD)(0xc0+ch), ctr);		/* ڼ޽Ǎ */
	else if(ch<2) ct520_rZUReg(hDevID, (WORD)(0xc0+(ch-2)), ctr);	/* ڼ޽Ǎ */
}

/****************************************************/
/* b`f[^Ǎ									*/
/*   @\ Fb`f[^Ǎ݂܂B				*/
/*   hDevID FfoCXnh						*/
/*   ch   F`l(0:Xch, 1:Ych, 2:Zch, 3:Uch)	*/
/*   ltc  Fb`f[^̒l						*/
/*    Ǎ Xch,Zch=0xca, Ych,Uch=0xcb			*/
/****************************************************/
void sct520_ReadLtc(DWORD hDevID, WORD ch, long* ltc)
{
	if(ch<2)      ct520_rXYReg(hDevID, (WORD)(0xca+ch), ltc);		/* ڼ޽Ǎ */
	else if(ch<4) ct520_rZUReg(hDevID, (WORD)(0xca+(ch-2)), ltc);	/* ڼ޽Ǎ */
}

/****************************************************/
/* őlf[^Ǎ									*/
/*   @\ Főlf[^Ǎ݂܂B				*/
/*   hDevID FfoCXnh						*/
/*   ch   F`l(0:Xch, 1:Ych, 2:Zch, 3:Uch)	*/
/*   max  Főlf[^̒l						*/
/*    Ǎ Xch,Zch=0xcc, Ych,Uch=0xce			*/
/****************************************************/
void sct520_ReadMax(DWORD hDevID, WORD ch, long* max)
{
	if(ch<2)      ct520_rXYReg(hDevID, (WORD)(0xcc + (ch << 1)), max);		/* ڼ޽Ǎ */
	else if(ch<4) ct520_rZUReg(hDevID, (WORD)(0xcc + ((ch-2) << 1)), max);	/* ڼ޽Ǎ */
}

/****************************************************/
/* ŏlf[^Ǎ									*/
/*   @\ Fŏlf[^Ǎ݂܂B				*/
/*   hDevID FfoCXnh						*/
/*   ch   F`l(0:Xch, 1:Ych, 2:Zch, 3:Uch)	*/
/*   min  Fŏlf[^̒l						*/
/*    Ǎ Xch,Zch=0xcd, Ych,Uch=0xcf			*/
/****************************************************/
void sct520_ReadMin(DWORD hDevID, WORD ch, long* min)
{
	if(ch<2)      ct520_rXYReg(hDevID, (WORD)(0xcd + (ch << 1)), min);		/* ڼ޽Ǎ */
	else if(ch<4) ct520_rZUReg(hDevID, (WORD)(0xcd + ((ch-2) << 1)), min);	/* ڼ޽Ǎ */
}

/****************************************************/
/* JE^NA									*/
/*   @\ FJE^NA(=0)܂B			*/
/*   hDevID FfoCXnh						*/
/*   ch   F`l(0:Xch, 1:Ych, 2:Zch, 3:Uch)	*/
/*     Xch,Zch=0x01, Ych,Uch=0x02			*/
/****************************************************/
void sct520_ClrCtr(DWORD hDevID, WORD ch)
{
	if(ch<2)      ct520_wXYCmd(hDevID, (WORD)(ch+1));	/* Pƺޏ */
	else if(ch<4) ct520_wZUCmd(hDevID, (WORD)(ch-1));	/* Pƺޏ */
}

/****************************************************/
/* MaxMin										*/
/*   @\ Főlŏl(=݂̃JEgl)	*/
/*   hDevID FfoCXnh						*/
/*   ch   F`l(0:Xch, 1:Ych, 2:Zch, 3:Uch)	*/
/*     Xch,Zch=0x04, Ych,Uch=0x08			*/
/****************************************************/
void sct520_InitMM(DWORD hDevID, WORD ch)
{
	if(ch<2)	  ct520_wXYCmd(hDevID, (WORD)(4 + (ch << 2)));		/* Pƺޏ */
	else if(ch<4) ct520_wZUCmd(hDevID, (WORD)(4 + ((ch-2) << 2)));	/* Pƺޏ */
}

/****************************************************/
/* MaxMinJn									*/
/*   @\ FMaxMinJn܂B					*/
/*   hDevID FfoCXnh						*/
/*   ch   F`l(0:Xch, 1:Ych, 2:Zch, 3:Uch)	*/
/*     Xch,Zch=0x48, Ych,Uch=0x4a			*/
/****************************************************/
void sct520_StrtMM(DWORD hDevID, WORD ch)
{
	if(ch<2)	  ct520_wXYCmd(hDevID, (WORD)(0x48 + (ch << 1)));		/* Pƺޏ */
	else if(ch<4) ct520_wZUCmd(hDevID, (WORD)(0x48 + ((ch-2) << 1)));	/* Pƺޏ */
}

/****************************************************/
/* MaxMinI									*/
/*   @\ FMaxMinI܂B					*/
/*   hDevID FfoCXnh						*/
/*   ch   F`l(0:Xch, 1:Ych, 2:Zch, 3:Uch)	*/
/*     Xch,Zch=0x49, Ych,Uch=0x4b			*/
/****************************************************/
void sct520_StopMM(DWORD hDevID, WORD ch)
{
	if(ch<2)      ct520_wXYCmd(hDevID, (WORD)(0x49 + (ch << 1)));		/* Pƺޏ */
	else if(ch<4) ct520_wZUCmd(hDevID, (WORD)(0x49 + ((ch-2) << 1)));	/* Pƺޏ */
}
