//***********************************************************
//  HPCI-CTR520F series
//  Driver I/F DLL function for C#.NET2003
//      file name:hictr520.cs
//      date     :2010/06/11
//      version  :1.00
//***********************************************************
using System;
using System.Runtime.InteropServices;

namespace spct5204
{
	/// <summary>
	/// hictr520 ̊Tv̐łB
	/// </summary>
	public class hictr520
	{

		// 萔`
		public const uint INVALID_BUS_NUMBER	= 0xFFFFFFFF;	// ȃoXԍ
		public const uint INVALID_DEV_NUMBER	= 0xFFFFFFFF;	// ȃfoCXԍ
		public const uint INVALID_IO_ADDRESS	= 0xFFFFFFFF;	//  I/O AhX
		public const uint INVALID_IRQ_NUMBER	= 0xFFFFFFFF;	//  IRQ ԍ
		public const uint INVALID_HPC_NUMBER	= 0xFFFFFFFF;	// ȊǗԍ
		public const uint INVALID_BOARD_ID		= 0xFFFFFFFF;	// ȃ{[hID

		// foCX\
		public struct HPCDEVICEINFO
		{
			public uint nBusNumber;				// oXԍ
			public uint nDeviceNumber;			// foCXԍ
			public uint dwIoPortAddress;		// I/O|[gAhX
			public uint dwIrqNo;				// IRQԍ
			public uint dwNumber;				// Ǘԍ(Windows 95/98/Meł͖)
			public uint dwBoardID;				// {[hID
		}

		public hictr520()
		{
			// 
			// TODO: RXgN^ WbNɒǉĂB
			//
		}

		// DLL֐`

		// (1) {[h̎擾(FfoCX̌)
		[DllImport("hictr520.dll")]
		public static extern uint ct520_GetDeviceCount(ref uint HpcDevNum);

		// (2) foCX̎擾(FfoCX̌AfoCX񃊃Xg̐擪AhX)
		[DllImport("hictr520.dll")]
		public static extern uint ct520_GetDeviceInfo(ref uint HpcDevNum, ref HPCDEVICEINFO HpcDevInfo);

		// (3) foCX̃I[v(FfoCX̃AhX)
		[DllImport("hictr520.dll")]
		public static extern uint ct520_OpenDevice(ref uint hDevID, ref HPCDEVICEINFO HpcDevInfo);

		// (4) foCXN[Y(FfoCXnh)
		[DllImport("hictr520.dll")]
		public static extern uint ct520_CloseDevice(uint hDevID);

		// (5) Xe[^XǍ(FfoCXnhAf[^i[)
		[DllImport("hictr520.dll")]
		public static extern uint ct520_rXYSts(uint hDevID, ref ushort wSts);
		[DllImport("hictr520.dll")]
		public static extern uint ct520_rZUSts(uint hDevID, ref ushort wSts);

		// (6) R}h(FfoCXnhApf[^)
		[DllImport("hictr520.dll")]
		public static extern uint ct520_wXYCmd(uint hDevID, ushort cmd);
		[DllImport("hictr520.dll")]
		public static extern uint ct520_wZUCmd(uint hDevID, ushort cmd);

		// (7) [hWX^Ǎ(FfoCXnhAf[^i[)
		[DllImport("hictr520.dll")]
		public static extern uint ct520_rXYReg(uint hDevID, ushort cmd, ref uint reg);
		[DllImport("hictr520.dll")]
		public static extern uint ct520_rZUReg(uint hDevID, ushort cmd, ref uint reg);

		// (7) CgWX^(FfoCXnhApf[^)
		[DllImport("hictr520.dll")]
		public static extern uint ct520_wXYReg(uint hDevID, ushort cmd, uint reg);
		[DllImport("hictr520.dll")]
		public static extern uint ct520_wZUReg(uint hDevID, ushort cmd, uint reg);

		// (8) IvV|[gPoCgǍ(FfoCXnhAf[^i[)
		[DllImport("hictr520.dll")]
		public static extern uint ct520_rPortB(uint hDevID, byte offset, ref byte byData);

		// (8) IvV|[gQoCgǍ(FfoCXnhAf[^i[)
		[DllImport("hictr520.dll")]
		public static extern uint ct520_rPortW(uint hDevID, byte offset, ref ushort wData);

		// (8) IvV|[gPoCg(FfoCXnhApf[^)
		[DllImport("hictr520.dll")]
		public static extern uint ct520_wPortB(uint hDevID, byte offset, byte byData);

		// (8) IvV|[gQoCg1(FfoCXnhApf[^)
		[DllImport("hictr520.dll")]
		public static extern uint ct520_wPortW(uint hDevID, byte offset, ushort wData);

		// (9) o̓obt@Ǎ(FfoCXnhAf[^i[)
		[DllImport("hictr520.dll")]
		public static extern uint ct520_rXYBuf(uint hDevID, ref uint reg);
		[DllImport("hictr520.dll")]
		public static extern uint ct520_rZUBuf(uint hDevID, ref uint reg);

		// (9) o̓obt@(FfoCXnhApf[^)
		[DllImport("hictr520.dll")]
		public static extern uint ct520_wXYBuf(uint hDevID, uint reg);
		[DllImport("hictr520.dll")]
		public static extern uint ct520_wZUBuf(uint hDevID, uint reg);

	}
}
